/* System.c -- env.core.System  ENI ڵ
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eRE.

eRE is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eRE is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#include "apr.h"
#include "apr_portable.h"
#include "apr_strings.h"
#include "apr_thread_proc.h"
#include "apr_signal.h"
#define APR_WANT_STDIO
#define APR_WANT_STRFUNC
#include "apr_want.h"

#if APR_HAVE_UNISTD_H
#include <unistd.h>
#endif
#if APR_HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#define CORE_PRIVATE

#include "ap_config.h"
#include "httpd.h"
#include "scoreboard.h"

#include "vm.h"

/**
  ݵ SRC  ArrayRef ̴.
  ݵ DST  ArrayRef ̴.
*/
void
env_core_System_arraycopy0 (src, src_pos, dst, dst_pos, len)
     eref_t src, dst;
     eint_t src_pos, dst_pos, len;
{
  char *in, *out;
  int element_size;
  env_t sc, dc;
  etype_t *stype, *dtype;
  
  stype = EARRAYREF_TYPE (src);
  dtype = EARRAYREF_TYPE (dst);

  element_size = ETYPE_SIZE (stype);

  in = &(((char *) EARRAYREF_DATA (src))[src_pos]);
  out = &(((char *) EARRAYREF_DATA (dst))[dst_pos]);

  if (stype == dtype)
    {
#ifdef HAVE_MEMMOVE
      memmove ((void *) out, (void *) in, (size_t) len);
#else
      /* Do it ourself */
#ifdef HAVE_MEMCPY
      if (src != dst)
	memcpy ((void *) out, (void *) in, (size_t) len);
      else
#endif
	if (out < in)
	  {
	    /* Copy forwards */
	    for (; len > 0; len--)
	      *out++ = *in++;
	  }
	else
	  {
	    /* Copy backwards */
	    out += len;
	    in += len;
	    for (; len > 0; len--)
	      *--out = *--in;
	  }
#endif
    }
  else
    {
      if (ETYPE_IS_PRIMITIVE (stype) || ETYPE_IS_PRIMITIVE (dtype))
	{
	  char str[MAX_STRING_SIZE];

	  snprintf (str, MAX_STRING_SIZE, "incompatible array types `%s' and `%s'",
		    ETYPE_SIGNITURE (stype), ETYPE_SIGNITURE (dtype));

	  throw_exception (call_constructor ("env.core.ArrayStoreException", 
					     NULL, 
					     "(Le://localhost:8889/env/core/string;)V", 
					     char_to_eobject (str, strlen (str))));
	  /* don't return.  */
	}

      for (; len > 0; len -= sizeof (eref_t))
	{
	  eref_t val = * (eref_t *) in;
	  
#if 0
	  if (ETYPE_KIND (dtype) == ETYPE_OBJECTREF)
	    dc = ETYPE_U_ENV (dtype);

	  if (val && instanceof (dc, ˼))
	    ;
#endif

	  * (eref_t *) out = val;
	  in += sizeof (eref_t);
	  out += sizeof (eref_t);
	}
    }
}
