/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ENV_FILE_H
#define ENV_FILE_H

/* Environment  Ŀ  .  */
enum environment_filetype
  {
    EFILE_INVALID	= 0,
    /* Eserver κ ̳ʸ   , ̰ ϵȴ.  */
    EFILE_BYTEARRAY	= 1
  };

#define EFILE_FILEPATH(NODE)		((NODE)->filepath)
#define EFILE_KEY(NODE)			((NODE)->key)
#define EFILE_BUFBASE(NODE)		((NODE)->bufbase)
#define EFILE_BUFCUR(NODE)		((NODE)->bufcur)
#define EFILE_BUFCUR_ARRAY(NODE, IDX)	((NODE)->bufcur[(IDX)])
#define EFILE_BUFLEN(NODE)		((NODE)->buflen)
#define EFILE_TYPE(NODE)		((NODE)->type)

#define EFILE_UNIQUE_ID_STARTING_POINT		0x8

struct environment_file
{
  /* Environment   ý Ͻý  .     environment
      ؼϸ鼭  Ǵ ٸ environment  θ ϴµ ȴ.

     Environment  δ   Ȥ η  ۼ 
     ְ Ǿֱ ̴.  */
  char *filepath;

  /* Environment  unique KEY.  */
  envkey_t *key;
  
  /* Virtual Machine  operation (LOAD )  ؾ ϴ 
     environment   ̳ʸ    ִ.  */
  unsigned char *bufbase;
  unsigned char *bufcur;
  size_t buflen;

  enum environment_filetype type;
};

typedef struct environment_file efile_t;

enum read_attribute_type 
  {
    READATTR_METHOD = 11,
    READATTR_ENVIRONMENT  = 12,
    READATTR_FIELD  = 13
  };

/* Environment Binary Format   type .   EBF   쿡 Ѵ.  */
#if defined(__STDC__)
#if !defined(HAVE_INT8)
typedef signed char		int8;
#endif
#elif defined(__CHAR_UNSIGNED__)
#error "no signed char type"
#else
#if !defined(HAVE_INT8)
typedef	char			int8;
#endif
#endif

#if !defined(HAVE_UINT8)
typedef	unsigned char		uint8;
#endif

#if SIZEOF_SHORT == 2
#if !defined(HAVE_INT16)
typedef	short			int16;
#endif
#if !defined(HAVE_UINT16)
typedef	unsigned short		uint16;
#endif
#else
#error "sizeof(short) must be 2"
#endif

/* If you change these definitions, also change strtod("-0.0") check
 * in configure.in
 */
#if SIZEOF_INT == 4
#if !defined(HAVE_INT32)
typedef	int			int32;
#endif
#if !defined(HAVE_UINT32)
typedef	unsigned int		uint32;
#endif
#elif SIZEOF_LONG == 4
#if !defined(HAVE_INT32)
typedef	long			int32;
#endif
#if !defined(HAVE_UINT32)
typedef	unsigned long		uint32;
#endif
#else
#error "sizeof(int) or sizeof(long) must be 4"
#endif

/* If you change these definitions, also change strtod("-0.0") check
 * in configure.in
 */
#if SIZEOF_LONG == 8
#if !defined(HAVE_INT64)
typedef	long			int64;
#endif
#if !defined(HAVE_UINT64)
typedef	unsigned long		uint64;
#endif
#elif SIZEOF_LONG_LONG == 8
#if !defined(HAVE_INT64)
typedef	long long		int64;
#endif
#if !defined(HAVE_UINT64)
typedef	unsigned long long	uint64;
#endif
#elif SIZEOF___INT64 == 8
#if !defined(HAVE_INT64)
typedef	__int64			int64;
#endif
#if !defined(HAVE_UINT64)
typedef	unsigned __int64	uint64;
#endif
#else
#error "sizeof(long) or sizeof(long long) or sizeof(__int64) must be 8"
#endif

#if SIZEOF_VOID_P == 4
typedef uint32			uintp;
#elif SIZEOF_VOID_P == 8
typedef uint64			uintp;
#else
#error "sizeof(void*) must be 4 or 8"
#endif

/* The arm32, while being a little endian machine, uses a big endian
 * word order for its doubles.  The arm32 uses software floating point 
 * emulation.  We define this constant to declare that the word order
 * in a 64bit double is the opposite of the word order in a 64bit int.
 *
 * If you change this definition, also change strtod("-0.0") check
 * in configure.in.
 */
#if defined(arm32) || (defined(arm) && defined(linux))
#define DOUBLE_ORDER_OPPOSITE
#endif

typedef uint8	        u1;
typedef uint16		u2;
typedef uint32		u4;
typedef u1		bytecode;

#define PTR_TYPE_SIZE	SIZEOF_VOID_P

#define WORDS_TO_LONG(HI, LO)		(((uint64) (HI) << 32) | (uint64) (uint32) (LO))

#endif
