/* eni.h - Environment Native Interface  .
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ESERVER_ENI_H
#define ESERVER_ENI_H

#ifndef PATH_MAX
#define PATH_MAX 1024
#endif

#ifndef MAXPATHLEN
# ifdef PATH_MAX
#  define MAXPATHLEN PATH_MAX
# else
#  define MAXPATHLEN 256    /* Should be safe for any weird systems that do not define it */
# endif
#endif

#define MAX_STRING_SIZE		(1024 * 8)

/*
  ENI  ϴ type  ǵԴϴ.
*/
#include "etype.h"

#define ENI_TRUE	1
#define ENI_FALSE	0

struct ENINativeInterface
{
  void *reserved0;	/* 0 */
  void *reserved1;	/* 1 */
  void *reserved2;	/* 2 */
  void *reserved3;	/* 3 */
};

typedef const struct ENINativeInterface *eni_t;

extern struct ENINativeInterface eserver_ENINativeInterface;

/* String Object  C ڿ Ѵ. */
extern char * eobject_to_char_buffer (void *, char *, int);
/* PATH  Ǿ ִ library  load Ѵ.  */
extern int load_nativelib (void *, char *);
extern void *get_eserver_pool (void);

#endif
