/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ENV_H
#define ENV_H

#define ENV_MAGIC_TYPE			"application/x-etpd-env"
#define ENV_FILE_EXTENSION		".eclass"
#define ENV_SOURCE_FILE_EXTENSION	".elang"
#define ENVIRONMENT_MAGIC		0xcafebeaf
#define	MAJOR_VERSION_V1_0		1
#define	MINOR_VERSION_V1_0		0

/** TSRM   erequest_t ü fetch Ѵ.   ũδ ׻ 
   Լ erequest_t ü   ȴ.  Ʒ Լ  
    0  ׻ erequest_t ü  tsrm_malloc () Լ  
    ȣǱ  0 index ̴.

   !!  erequest_t ü  tsrm_malloc () Լ ȣ 
     ݵ  index ȣ  ־ Ѵ.  */
#define FETCH_EREQUEST			((erequest_t *) tsrm_fetch (0))
#define FETCH_EREQUEST_INFO(NAME)	(REQUEST_INFO ((FETCH_EREQUEST))->##NAME)

/* setjmp  longjmp  ̿Ͽ  try/catch .  */
#define elang_try							\
	{								\
	  jmp_buf orig_bailout;						\
	  erequest_t *__erval = FETCH_EREQUEST;				\
          int orig_bailout_set = RCONTENT_BAILOUT_SET (REQUEST_INFO (__erval));	\
									\
	  RCONTENT_BAILOUT_SET (REQUEST_INFO (__erval)) = 1;	\
	  memcpy (&orig_bailout, &RCONTENT_BAILOUT_SET (REQUEST_INFO (__erval)), sizeof (jmp_buf));	\
	  if (!setjmp (RCONTENT_BAILOUT (REQUEST_INFO (__erval))))
#define elang_catch							\
	  else
#define elang_try_end							\
	  memcpy (&RCONTENT_BAILOUT (REQUEST_INFO (__erval)), &orig_bailout, sizeof (jmp_buf));	\
	  RCONTENT_BAILOUT (REQUEST_INFO (__erval)) = orig_bailout_set;		\
	}
#define elang_try_first							\
        FETCH_EREQUEST_INFO (bailout_set) = 0;	\
        etry

typedef union envunion_def *env_t;
typedef union erefs_def *erefs_t;
typedef struct emethod emethod_t;
typedef struct efield efield_t;
typedef struct eobjectref eobjectref_t;
typedef struct earrayref earrayref_t;
typedef struct string_constant strconst_t;
typedef struct econst_pool econst_pool_t;
typedef struct access_hosts access_hosts_t;
typedef struct etype etype_t;
typedef struct evalue evalue_t;
typedef struct environment_args eargs_t;
typedef struct VMexception eexcep_t;

/*
  Constant Strings.
*/
#define STRCONST_HASH(SC)		((SC)->hash)
#define STRCONST_PTR(SC)		((SC)->buf)
#define STRCONST_BUFFER_IDX(SC, IDX)	((SC)->buf[(IDX)])
#define STRCONST_LENGTH(SC)		((SC)->len)

struct string_constant
{
  int hash;
  char *buf;
  int len;
};

/*
  Environment Structure.
*/

/** Environment  ¸ Ÿ flag .  ENV_STATE_UNLOADED  ؼ
   ENV_STATE_COMPLETE ± Ǵ  ü .  */
enum env_states
  {
    /** Step 1. ó environment ü ҴǸ, ü ´ 
       ENV_STATE_0_STRUCT_INITIALIZED  ʱȭ ̷.  ü 
       Ҵǰ ּ   ̴.  */
    ENV_STATE_0_STRUCT_INITIALIZED = 0,
    /** Step 2.  environment  ؼ.  */
    ENV_STATE_1_FILE_PARSING,
    /** Step 3.  environment  ؼ .  */
    ENV_STATE_2_FINISHED_FILE_PARSING,
    /** Step 4. Field  óѴ.  */
    ENV_STATE_4_PROCESS_FIELDS,
    /** Step 5. Method  óѴ.  */
    ENV_STATE_5_PROCESS_METHODS,
    /** Step 6. Constant Pool   ó   óѴ.  */
    ENV_STATE_6_PROCESS_CONSTANTS,
    /** Step 7. ش environment  super  óѴ.  */
    ENV_STATE_7_PROCESS_SUPER,
    /** Step 8. <clinit>  ó  ʾ   ó .  */
    ENV_STATE_8_USABLE,
    /** Step 9. <clinit> method  ȣϿ environment   ʱȭ Ѵ.  */
    ENV_STATE_9_PROCESS_CLINIT,
    /** Step n. Environment ü load Ϸ.  */
    ENV_STATE_COMPLETE,

    /** Step 0. Environment load .  */
    ENV_STATE_FAILED = -1
  };

/** Constant Pool   Ǵ type 鿡 ؼ, Ʒ Ǹ ش.  */
enum econst_tags
  {
    CONSTANT_Unknown		= 0,
    CONSTANT_Utf8		= 1,
    CONSTANT_Integer		= 3,
    CONSTANT_Float		= 4,
    CONSTANT_Long		= 5,
    CONSTANT_Double		= 6,
    CONSTANT_Environment	= 7,
    CONSTANT_String		= 8,
    CONSTANT_Fieldref		= 9,
    CONSTANT_Methodref		= 0xA,
    CONSTANT_InterfaceMethodref = 0xB,
    CONSTANT_NameAndType	= 0xC,
    /** Access Flag   .  */
    CONSTANT_Accessref		= 0x10,
    /**   environment  SHA1  Ų.  */
    CONSTANT_Sha1This		= 0x11,
    /** ش SHA1   ִ.  */
    CONSTANT_Sha1		= 0x12,
    CONSTANT_Sha1AndName	= 0x13,
    CONSTANT_Host               = 0x14,
    /** CONSTANT_ResolvedEnvironment  , environment  ε , 
       CONSTANT_Environment  ̰ ȴ.  */
    CONSTANT_ResolvedEnvironment	= 0x27,
    /** CONSTANT_EnvedString  String  , Ư ó ־ ϱ ,
        enumberator  Ѵ.  String  , ϳ environment ν
       óǾ ϱ ̴.  */
    CONSTANT_EnvedString	= 0x28
  };

/** Environment  ϰ  constant pool   ü̴.  TAGS  
   Ǿִ enum constant  ϳ  Ǹ, DATA    int  
   Ǿ , δ 4 Ʈ   ǹ̰  ũ.  ׷ ο 
   , Ǽ,   ȴ.  */
#define CONSTPOOL_SIZE(NODE)		((NODE)->size)
#define CONSTPOOL_TAGS(NODE)		((NODE)->tags)
#define CONSTPOOL_TAGS_IDX(NODE, IDX)	((NODE)->tags[(IDX)])
#define CONSTPOOL_DATA(NODE)		((NODE)->data)
#define CONSTPOOL_DATA_IDX(NODE, IDX)	((NODE)->data[(IDX)])

#define CONSTPOOL_INT(NODE, IDX)	((int32) CONSTPOOL_DATA_IDX (NODE, IDX))
#define CONSTPOOL_LONG(NODE, IDX)	WORDS_TO_LONG (CONSTPOOL_DATA_IDX (NODE, IDX), CONSTPOOL_DATA_IDX (NODE, IDX+1))
#define	CONSTPOOL_DOUBLE(NODE, IDX)	CLASS_CONST_LONG (NODE, IDX)
/* The first uint16 of the INDEX'th constant pool entry. */
#define CONSTPOOL_USHORT1(NODE, IDX)	(CONSTPOOL_DATA_IDX (NODE, IDX) & 0xFFFF)
/* The second uint16 of the INDEX'th constant pool entry. */
#define CONSTPOOL_USHORT2(NODE, IDX)	((ushort16) (CONSTPOOL_DATA_IDX (NODE, IDX) >> 16))

#define ENV_CONSTPOOL_LONG(CL, IDX)		\
  WORDS_TO_LONG (CONSTPOOL_DATA_IDX (ENV_CONSTANT_POOL (CL), IDX), \
                 CONSTPOOL_DATA_IDX (ENV_CONSTANT_POOL (CL), IDX))
#define	ENV_CONSTPOOL_DOUBLE(CL, IDX)	ENV_CONSTPOOL_LONG (CL, IDX)

#define	METHODREF_ENVIRONMENT(POOL, IDX)	((int) (CONSTPOOL_DATA_IDX (POOL, IDX) & 0xffff))
#define	METHODREF_NAMEANDTYPE(POOL, IDX)	((int) (CONSTPOOL_DATA_IDX (POOL, IDX) >> 16))
#define ENVIRONMENT_HOST(POOL, IDX)		(METHODREF_ENVIRONMENT (POOL, IDX))
#define ENVIRONMENT_SHA1ANDNAME(POOL, IDX)	(METHODREF_NAMEANDTYPE (POOL, IDX))
#define SHA1ANDNAME_SHA1(POOL, IDX)		(METHODREF_ENVIRONMENT (POOL, IDX))
#define SHA1ANDNAME_NAME(POOL, IDX)		(METHODREF_NAMEANDTYPE (POOL, IDX))
#define	FIELDREF_ENVIRONMENT(POOL, IDX)		(METHODREF_ENVIRONMENT (POOL, IDX))
#define	FIELDREF_NAMEANDTYPE(POOL, IDX)		(METHODREF_NAMEANDTYPE (POOL, IDX))
#define	NAMEANDTYPE_NAME(POOL, IDX)		(METHODREF_ENVIRONMENT (POOL, IDX))
#define	NAMEANDTYPE_TYPE(POOL, IDX)		(METHODREF_NAMEANDTYPE (POOL, IDX))
#define HOST_NAME(POOL, IDX)			(METHODREF_ENVIRONMENT (POOL, IDX))
#define HOST_PORT(POOL, IDX)			(METHODREF_NAMEANDTYPE (POOL, IDX))

struct econst_pool
{
  u4	size;
  u1	*tags;
  int	*data;
};

/** Environment  ϴ field  method    ִ, ѿ ؼ
   Ѵ.  */

enum env_access_flags
  {
    AF_PUBLIC		= 0x0001,
    AF_PRIVATE		= 0x0002,
    AF_PROTECTED	= 0x0004,
    AF_STATIC		= 0x0008,
    AF_FINAL		= 0x0010,
    AF_SUPER		= 0x0020,
    AF_SYNCHRONIZED	= 0x0020,
    AF_VOLATILE		= 0x0040,
    AF_TRANSIENT	= 0x0080,
    AF_NATIVE		= 0x0100,
    AF_INTERFACE	= 0x0200,
    AF_ABSTRACT       	= 0x0400,
    AF_STRICT		= 0x0800,
    /* ENI ̸   native interface  ,  flag  ȴ.  */
    AF_ENI		= 0x2000,
    /*  native method  ϴ shared library   ߰ߵǾ
       ,  flag  ȴ.  */
    AF_TRANSLATED	= 0x4000,
    AF_CONSTANT_VALUE	= 0x4000
  };

#define	AF_MASK			0x07FF
#define AF_CONSTRUCTOR		0x0800

#define ACCESS_HOSTS_SIZE(AH)		((AH)->size)
#define ACCESS_HOSTS_DATA(AH)		((AH)->data)
#define ACCESS_HOSTS_DATA_IDX(AH, IDX)	((AH)->data[(IDX)])

struct access_hosts
{
  u4	size;
  int	*data;
};

/*************************************************************************
 * Environment Type.
 *************************************************************************/

enum evalue_type
  {
#define DEF_ETYPES(ENUM, NAME, SIZE, SLOT)	ENUM,
#include "etype.def"
#undef DEF_ETYPES
    MAX_ETYPE
  };

extern const char *etype_name[MAX_ETYPE];
extern const int etype_size[MAX_ETYPE];
extern const int etype_slot[MAX_ETYPE];

#define ETYPE_KIND(NODE)		((NODE)->kind)
/**  TYPE   ̻ resolve    , 1  Ǹ, ⺻
   0  ȴ.  */
#define RESOLVED_ETYPE			1
#define NO_RESOLVED_ETYPE		0
#define ETYPE_IS_RESOLVED(NODE)		((NODE)->is_resolved)
#define ETYPE_IS_PRIMITIVE(NODE)	((NODE)->is_primitive)
#define ETYPE_SIGNITURE(NODE)		((NODE)->sig)
#define ETYPE_SIGNITURE_IDX(NODE, IDX)	((NODE)->sig[(IDX)])
#define ETYPE_SIZE(NODE)		((NODE)->size)
#define ETYPE_U_ENV(NODE)		((NODE)->u.e)
#define ETYPE_U_PTYPE(NODE)		((NODE)->u.ptype)

struct etype
{
  /**  TYPE   Ÿ.  */
  enum evalue_type kind;

  unsigned is_resolved : 1;
  unsigned is_primitive : 1;
  unsigned unused : 30;

  /** TYPE .  */
  char *sig;

  /**  TYPE  ũ.  */
  int size;

  union
  {
    struct etype *ptype;
    /** TYPE   ETYPE_OBJECT  , ش environment ü Ʒ 
       ȴ.  */
    env_t e;
  } u;
};

/*************************************************************************
 * Environment Value.
 *************************************************************************/

/**
   <pre> 
   [ϴ ]
   +-----------------------------------------------------------------------------+
   | Keyword      | Description                        | Size/Format             |
   +-----------------------------------------------------------------------------+
         (integers) 
     byte           Byte-length integer                  8-bit two's complement 
     short          Short integer                        16-bit two's complement 
     int            Integer                              32-bit two's complement 
     long           Long integer                         64-bit two's complement 
         (real numbers) 
     float          Single-precision floating point      32-bit IEEE 754 
     double         Double-precision floating point      64-bit IEEE 754 
         (other types) 
     char           A single character                   16-bit Unicode character 
     boolean        A boolean value (true or false)      true or false 
     ref            Reference to address.                System's address size.
   +-----------------------------------------------------------------------------+  

   [迭 ]

       <array></array> TAG  Ͽ, ش  ش.

   [ TAG ]
 
     * Object 
       <new>

     * Method  Field ȣ 
       <call>		<return>

     *  
       <arg>
       <byte>		<short>		<long>		<int>
       <float>		<double>
       <char>		<boolean>	<ref>
       <array>
       <array_ref>
       <object>
       <object_ref>
   </pre>
*/

#define EVALUE_TYPE(NODE)		((NODE)->type)
#define EVALUE_IS_REMOTE(NODE)		((NODE)->is_remote)
#define EVALUE_IS_COMPLETE(NODE)	((NODE)->is_complete)
#define EVALUE_REFCOUNT(NODE)		((NODE)->refcount)
#define EVALUE_BYTE(NODE)		((NODE)->v.ebyte)
#define EVALUE_SHORT(NODE)		((NODE)->v.eshort)
#define EVALUE_INT(NODE)		((NODE)->v.eint)
#define EVALUE_LONG(NODE)		((NODE)->v.elong)
#define EVALUE_FLOAT(NODE)		((NODE)->v.efloat)
#define EVALUE_DOUBLE(NODE)		((NODE)->v.edouble)
#define EVALUE_CHAR(NODE)		((NODE)->v.echar)
#define EVALUE_BOOLEAN(NODE)		((NODE)->v.eboolean)
#define EVALUE_OBJECT(NODE)		((NODE)->v.eaddr)
#define EVALUE_ARRAY(NODE)		((NODE)->v.eaddr)
#define EVALUE_ADDRESS(NODE)		((NODE)->v.eaddr)
#define EVALUE_STRING(NODE)		((NODE)->v.estr)

struct evalue
{
  etype_t *type;

  /**     𼭺 ߴ Ÿ.   0  , Local Machine
       Ǵ ̰,  1  , Remote Machine  Ǵ ̴.  */
  unsigned is_remote : 1;
  /**   EVALUE    ϷǾ ,  1  ǰ, ׷   0 
      ȴ.  */
  unsigned is_complete : 1;
  unsigned unused : 30;

  unsigned short refcount;

  /** Variable information */
  union
  {
    ebyte_t	ebyte;
    eshort_t	eshort;
    eint_t	eint;
    elong_t	elong;
    efloat_t	efloat;
    edouble_t	edouble;
    echar_t	echar;
    eboolean_t	eboolean;
    eref_t	eaddr;
    char	*estr;
  } v;
};

/**
   EVALUE   NULL  Ѵ.

   !!   struct evalue ü  , Ʒ definition  ؾ
   Ѵ.  
*/
#define EVALUE_NULL			{ NULL, 0, 0, 0, 0, { 0 } }

#define EARGS_VARIABLE(NODE)		((NODE)->var)
#define EARGS_VALUE(NODE)		((NODE)->value)

/** Environment  ޵Ǵ .  eserver κ ޵Ǵ ڵ.  */
struct environment_args
{
  /**  ̸.  */
  char *var;

  /** .  */
  evalue_t *value;
};

/*************************************************************************
 * EFIELD
 *************************************************************************/

#define FIELD_NAME(NODE)			((NODE)->name)
#define FIELD_ACCESS_FLAGS(NODE)		((NODE)->af)
#define FIELD_ACCESS_HOSTS(NODE)		((NODE)->ah)
#define FIELD_TYPE(NODE)			((NODE)->type)
#define FIELD_STATIC_DATA_INDEX(NODE)		((NODE)->info.sdi)
#define FIELD_OBJECT_DATA_OFFSET(NODE)		((NODE)->info.odf)
#define FIELD_TYPE_CONSTPOOL_IDX(NODE)		((NODE)->info.tci)
#define FIELD_CONSTANT_INDEX(NODE)		((NODE)->info.idx)
#define FIELD_IS_OBJECTREF_OR_ARRAYREF_TYPE(NODE)	\
  (ETYPE_KIND (FIELD_TYPE (NODE)) == ETYPE_OBJECTREF	\
   || ETYPE_KIND (FIELD_TYPE (NODE)) == ETYPE_ARRAYREF)
/** call.c  get_field ()  ȣ  ϴ ܼ flag .  */
#define STATIC_FIELD_FLAG			1
#define NON_STATIC_FIELD_FLAG			0

struct efield
{
  /**  field  ̸ .  */
  strconst_t *name;

  /** Field Access Flags/Hosts.  */
  enum env_access_flags af;
  access_hosts_t *ah;

  etype_t *type;

  union
  {
    /**  ̰ Ǿ ִٸ, ̰ non-static field   Ű, 
        object ref ü offset ̴.  Offset · Ǿ ִ 
       Ÿ     ϱ ؼ̴.  */
    off_t odf;

    /**   struct field  static  Ǿ 쿡, ȿ 
       struct environment ü  STATIC_DATA  index 
       Ų.  */
    u2 sdi;

    /**  type  'L' Ȥ '['   , ش type   environment 
       ٷ ó ʰ, process_env () Լ װ óѴ.  */
    u2 tci;

    /* ConstantValue   index */
    u2 idx;
  } info;
};

/*************************************************************************
 * EMETHOD
 *************************************************************************/

#define DISPATCH_ENV(DT)			((DT)->e)
#define DISPATCH_METHOD(DT)			((DT)->method)
#define DISPATCH_METHOD_IDX(DT, IDX)		((DT)->method[(IDX)])

/** Dispatch ̺  METHOD  offset  ϴµ, ⼭  1  fix  κ̱
   , Dispatch ̺  ,   *ݵ*  ־ Ѵ.  

   ⼭  1  Ʒ  void *method[1]     Ǿ ִĸ
   Ÿ.   env_t e  Ǿ ֱ   1 ̴.  */
#define	DISPATCH_METHODOFFSET			(sizeof (void *) * 1)

/** Dispatch ̺ method pointer  ϴ  Ѵ.  Ϲ pointer
    4  ũ⸦ .  */
#define	DISPATCH_METHODSIZE			(sizeof (void *))

/** Dispatch table  ʿ  environment  method  ϱ ؼ
   ׻ ش method  ּҸ ϴ  ŷӱ , ش struct method
     pointer  struct dispatch_table  ־ ν,  ϱ
   ؼ ̴.  */
struct dispatch_table
{
  env_t e;
  void *method[1];
};

struct linenumber_entry 
{
  uint16 line_nr;
  uintp start_pc;
};

#define LINENUMBER_LENGTH(NODE)			((NODE)->length)
#define LINENUMBER_ENTRY_START_PC(NODE, IDX)	((NODE)->entry[(IDX)].start_pc)
#define LINENUMBER_ENTRY_LINE_NR(NODE, IDX)	((NODE)->entry[(IDX)].line_nr)

struct linenumbers 
{
  uint32 length;
  struct linenumber_entry entry[1];
};

#define MEXCEPTION_START_PC(NODE, IDX)		((NODE)->entry[(IDX)].start_pc)
#define MEXCEPTION_END_PC(NODE, IDX)		((NODE)->entry[(IDX)].end_pc)
#define MEXCEPTION_HANDLER_PC(NODE, IDX)	((NODE)->entry[(IDX)].handler_pc)
#define MEXCEPTION_CATCH_IDX(NODE, IDX)		((NODE)->entry[(IDX)].catch_idx)
#define MEXCEPTION_CATCH_TYPE(NODE, IDX)	((NODE)->entry[(IDX)].catch_type)

struct mexception_entry
{
  uintp start_pc;
  uintp end_pc;
  uintp handler_pc;
  u2 catch_idx;
  env_t catch_type;
};

#define MEXCEPTION_LENGTH(NODE)			((NODE)->length)
#define MEXCEPTION_ENTRY(NODE)			((NODE)->entry)
#define MEXCEPTION_ENTRY_IDX(NODE, IDX)		((NODE)->entry[(IDX)])

struct mexception
{
  uint32 length;
  struct mexception_entry entry[1];
};

#define MTYPE_NAME(NODE)		((NODE)->name)
#define MTYPE_RETUEN(NODE)		((NODE)->ret)
#define MTYPE_ARGC(NODE)		((NODE)->argc)
#define MTYPE_ARGV(NODE)		((NODE)->argv)
#define MTYPE_ARGV_IDX(NODE, IDX)	((NODE)->argv[(IDX)])

struct emethod_type
{
  strconst_t *name;

  u2 argc;

  /** Ʒ ret  argv  name   offset ̴.  */
  u2 ret;
  u2 argv[1];
};

#define METHOD_INDEX(NODE)		((NODE)->idx)
#define METHOD_NAME(NODE)		((NODE)->name)
#define METHOD_ACCESS_FLAGS(NODE)	((NODE)->af)
#define METHOD_ACCESS_HOSTS(NODE)	((NODE)->ah)
#define METHOD_TYPE(NODE)		((NODE)->type)
#define METHOD_ARGC(NODE)		(MTYPE_ARGC (METHOD_TYPE (NODE)))
#define METHOD_ARGV(NODE)		(MTYPE_ARGV (METHOD_TYPE (NODE)))
#define METHOD_ARGV_IDX(NODE, IDX)	(MTYPE_ARGV_IDX (METHOD_TYPE (NODE), (IDX)))
#define METHOD_ARGV_IDX_CHAR(NODE, IDX)	\
	(STRCONST_BUFFER_IDX (MTYPE_NAME (METHOD_TYPE (NODE)), \
	                      MTYPE_ARGV_IDX (METHOD_TYPE (NODE), (IDX))))
#define METHOD_RET_CHAR(NODE)	\
	(STRCONST_BUFFER_IDX (MTYPE_NAME (METHOD_TYPE (NODE)), \
	                      MTYPE_RETUEN (METHOD_TYPE (NODE))))
#define METHOD_STACK_SIZE(NODE)		((NODE)->stacksz)
#define METHOD_LOCAL_SIZE(NODE)		((NODE)->localsz)
#define METHOD_BCODE(NODE)		((NODE)->c.bcode.code)
#define METHOD_BCODE_LENGTH(NODE)	((NODE)->c.bcode.codelen)
#define METHOD_NCODE_START(NODE)	((NODE)->c.ncode.ncode_start)
#define METHOD_LINES(NODE)		((NODE)->lines)
#define METHOD_EXCEPTION_TABLE(NODE)	((NODE)->exception_table)
#define METHOD_DECLARED_EXCEPTION_NUMBER(NODE)		((NODE)->ndeclared_exceptions)
#define METHOD_DECLARED_EXCEPTION(NODE)			((NODE)->declared_exceptions)
#define METHOD_DECLARED_EXCEPTION_IDX(NODE, IDX)	((NODE)->declared_exceptions[(IDX)])
#define METHOD_ENV(NODE)		((NODE)->e)

#define	METHOD_IS_STATIC(NODE)		((NODE)->af & AF_STATIC)
#define	METHOD_IS_CONSTRUCTOR(NODE)	((NODE)->af & AF_CONSTRUCTOR)
#define	METHOD_IS_FINAL(NODE)		((NODE)->af & AF_FINAL)
#define	METHOD_IS_PRIVATE(NODE)		((NODE)->af & AF_PRIVATE)

#define METHOD_TRANSLATED(NODE)		(METHOD_ACCESS_FLAGS (NODE) & AF_TRANSLATED)

struct emethod
{
  int idx;	/** Index into class->dtable (Dispatch Table).  */

  /**  method  ̸ .  */
  strconst_t *name;

  /** Method Access Flags/Hosts.  */
  enum env_access_flags af;
  access_hosts_t *ah;

  struct emethod_type *type;

  u2 stacksz;
  u2 localsz;

  union 
  {
    struct 
    {
      u1 *ncode_start;
      u1 *ncode_end;
    } ncode;
    struct 
    {
      u1 *code;
      int codelen;
    } bcode;
  } c;

  /** LineNumberTable attribute  ü.  */
  struct linenumbers *lines;
  struct mexception *exception_table;
  u2 ndeclared_exceptions;
  u2 *declared_exceptions;
  
  /*  method  environment.  */
  env_t e;
};

/*************************************************************************
 * Environment Common Structure.
 *************************************************************************/

/**
   Environment ü .
*/
enum env_struct_type
  {
    ENV_COMMON,
    ENV_LEO,
    ENV_REO
  };

#define ENV_TYPE(NODE)			((NODE)->common.type)
#define UNIQUE_ID_TYPE			unsigned int
#define ENV_UNIQUE_ID(NODE)		((NODE)->common.unique_id)
#define ENV_MPOOL(NODE)			((NODE)->common.mp)
#define ENV_MUTEX(NODE)			((NODE)->common.mutex)
#define ENV_KEY(NODE)			((NODE)->common.key)
#define ENV_STATE(NODE)			((NODE)->common.state)
#define ENV_SET_STATE(NODE, STATE)	(ENV_STATE (NODE) = (enum env_states) (STATE))

/** Environment ü ׻  شǴ     ִ.  
   ü ̰   ִ. */
struct env_common
{
  enum env_struct_type type;

  /** Environment  ݵ unique ID  .  */
  UNIQUE_ID_TYPE unique_id;

  /**   environment  ޸𸮸  memory pool.  */
  apr_pool_t *mp;

  /** Environment ü ó κ  locking  ʿ κп  mutex.  */
  apr_thread_mutex_t *mutex;

  /** Environment  unique KEY.  */
  envkey_t *key;

  /**  .  */
  enum env_states state;
};

/*************************************************************************
 * Local Environment Object.
 *************************************************************************/

/** Environment File   ִ   ü̸, environment 
   ۼڿ ̼   ִ.  */
struct env_private_info
{
  /**     ý 󿡼 ϴ  .  */
  char *filepath;

  /** Environment  ۼ  ̸.  */
  char *writer;

  /** Environment  ̼.  */
  char *license;
};

#define ENV_FILEPATH(NODE)		((NODE)->leo_def.epi.filepath)
#define ENV_WRITER(NODE)		((NODE)->leo_def.epi.writer)
#define ENV_LICENSE(NODE)		((NODE)->leo_def.epi.license)
#define ENV_CONSTANT_POOL(NODE)		((NODE)->leo_def.cp)
/** Hash table  ó ũ (rounded to next prime).  */
#define CONSTANT_HASH_INITIAL_SIZE	1000
#define ENV_CONSTANT_HASH_TABLE(NODE)	((NODE)->leo_def.const_hash_table)
#define ENV_ACCESS_FLAGS(NODE)		((NODE)->leo_def.af)
#define ENV_ACCESS_HOSTS(NODE)		((NODE)->leo_def.ah)
#define ENV_NAME(NODE)			((NODE)->leo_def.name)
#define ENV_THIS_INDEX(NODE)		((NODE)->leo_def.this_index)
#define ENV_SUPER_INDEX(NODE)		((NODE)->leo_def.super_index)
#define ENV_SUPER(NODE)			((NODE)->leo_def.super)
#define ENV_SOURCEFILE_NAME(NODE)	((NODE)->leo_def.sourcefile_name)
#define ENV_FIELDS(NODE)		((NODE)->leo_def.fields)
#define ENV_FIELDS_IDX(NODE, IDX)	((NODE)->leo_def.fields[(IDX)])
/** Environment  ϴ  FIELD   Ѵ.  ̰ field 
   static  Ǿ ִ ش field    ̴.  */
#define ENV_FIELDS_COUNT(NODE)		((NODE)->leo_def.nfields)
/** read_environment () ȯ泻,  field  ϱ  ӽ ϴ
   ̴.  bfsize   Ȯ  ߿ Ǿ.  */
#define ENV_FIELDS_TMPCOUNT(NODE)	((NODE)->leo_def.bfsize)
#define ENV_STATIC_FIELDS(NODE)		((NODE)->leo_def.fields)
/** Environment  ϴ static field      ִ.  */
#define ENV_STATIC_FIELDS_COUNT(NODE)	((NODE)->leo_def.nsfields)
#define ENV_STATIC_FIELDS_DATA(NODE)		((NODE)->leo_def.sfields_data)
#define ENV_STATIC_FIELDS_DATA_IDX(NODE, IDX)	((NODE)->leo_def.sfields_data[(IDX)])
#define ENV_INSTANCE_FIELDS(NODE)	((NODE)->leo_def.fields[(ENV_STATIC_FIELDS_COUNT (NODE))])
#define ENV_INSTANCE_FIELDS_COUNT(NODE)	((NODE)->leo_def.nfields - (NODE)->leo_def.nsfields)
#define ENV_FIELDS_SIZE_IN_BYTE(NODE)	((NODE)->leo_def.bfsize)

#define ENV_METHODS(NODE)		((NODE)->leo_def.methods)
#define ENV_METHODS_IDX(NODE, IDX)	((NODE)->leo_def.methods[(IDX)])
#define ENV_METHODS_COUNT(NODE)		((NODE)->leo_def.nmethods)
#define ENV_DISPATCH_TABLE(NODE)	((NODE)->leo_def.dtable)

#define ENV_INTERFACES(NODE)		((NODE)->leo_def.interfaces)
#define ENV_INTERFACE_IDX(NODE, IDX)	((NODE)->leo_def.interfaces[(IDX)])
#define ENV_INTERFACE_NUM(NODE)		((NODE)->leo_def.interface_num)
#define ENV_TOTAL_INTERFACE_NUM(NODE)	((NODE)->leo_def.total_interface_num)

#define ENV_IS_ARRAY(NODE)		(ENV_NAME (NODE) && STRCONST_BUFFER_IDX (ENV_NAME (NODE), 0) == '[')
#define ENV_IS_INTERFACE(NODE)		(ENV_ACCESS_FLAGS (NODE) & AF_INTERFACE)
#define ENV_IS_ABSTRACT(NODE)		(ENV_ACCESS_FLAGS (NODE) & AF_ABSTRACT)
#define ENV_IS_FINAL(NODE)		(ENV_ACCESS_FLAGS (NODE) & AF_FINAL)

/** Local Environment Object ü.  ϳ environment  ϴµ Ǵ
   ü.  */
struct env_leo
{
  /** Common Structure.  */
  struct env_common common;

  /**  environment  ϴ constant  (Identifier )  
         Hash Table ̴.  */
  vm_htab_t const_hash_table;

  /** Environment  ڿ ̼.  */
  struct env_private_info epi;

  /** Constant Pool.  */
  econst_pool_t *cp;

  /** Environment Access Flags/Hosts.  */
  enum env_access_flags af;
  access_hosts_t *ah;

  /**  environment  ̸.  */
  strconst_t *name;

  /**  environment  name   constant pool  index  
     Ÿ.  */
  int this_index;
  /** Super   constant pool  idx .  */
  int super_index;
  env_t super;

  char *sourcefile_name;

  /** Ʒ FIELDS  METHODS  迭  .  */
  efield_t *fields;
  /** Static  ƴ (non-static) field  ϴ ޸  뷮 ( field 
     ϰ   ).     object.c Ͽ objectref    Ҵ  ,
     ȴ.  Ʈ ũ̴.

       struct environment  primitive type   , ش TYPE  ũ̴.
      read_environment.c   ENVIRONMENT_FIELDS_TMPCOUNT ũο ؼ
       ȴ.  */
  int bfsize;
  /** Number of fields, including static fields. */
  int nfields;
  /** Number of static fields. */
  int nsfields;

  /** Environment  ϴ static field     ͸ 
     ִ.    struct variable_slots ü Ǳ ,  field 
      STATIC_DATA 迭 index ȣ  ־ Ѵ.  */
  evalue_t *sfields_data;

  /**  environment  Methods .  */
  emethod_t *methods;
  int nmethods;
  /**  environment   method 鿡     Ǵ dispatch table.  */
  struct dispatch_table *dtable;

  /** Interface  .  */
  env_t *interfaces;
  u2 interface_num;
  u2 total_interface_num;
};

#define RENV_UNPARSED_EURI(NODE)	((NODE)->reo_def.unparsed_euri)
#define RENV_HOSTNAME(NODE)		((NODE)->reo_def.hostname)
#define RENV_PORT(NODE)			((NODE)->reo_def.port)
#define RENV_NAME(NODE)			((NODE)->reo_def.name)
#define RENV_NAMELEN(NODE)		((NODE)->reo_def.namelen)
#define RENV_PARSED_EURI(NODE)		((NODE)->reo_def.parsed_euri)

/** Remote Environment Object ü.  */
struct env_reo
{
  struct env_common common;

  /* Remote  .  */

  /** The URI without any parsing performed */
  char *unparsed_euri;	

  /** The server hostname */
  char *hostname;
  /** Port ȣ. */
  apr_port_t port;

  /** Pathname for Name */
  const char *name;
  /** Length of path */
  int namelen;

  /** A struct containing the components of URI */
  euri_t parsed_euri;
};

/** Environment Union Structure.   environment ü ΰ ִ wrapper
   structure ̴.  */
union envunion_def
{
  struct env_common common;
  struct env_leo leo_def;
  struct env_reo reo_def;
};

/*************************************************************************
 * Environment Runtime Exception.
 *************************************************************************/

#define VMEXCEPTION_PREV(NODE)		((NODE)->prev)
#define VMEXCEPTION_OBJECTREF(NODE)	((NODE)->obj)
#define VMEXCEPTION_METHOD(NODE)	((NODE)->m)
#define VMEXCEPTION_JMP_BUF(NODE)	((NODE)->env)
#define VMEXCEPTION_PC(NODE)		((NODE)->pc)

/**
   VM     exception list ü.
 */
struct VMexception 
{
  struct VMexception *prev;

  eobjectref_t *obj;
  emethod_t *m;

  jmp_buf env;
  u4 pc;
};

struct stack_trace_info 
{
  uintp pc;
  emethod_t *m;
};

/*************************************************************************
 * Environment Object.
 *************************************************************************/

#define EREF_UNIQUE_IDX_TYPE		int

struct ecommonref
{
  int unused;
};

#define EOBJECTREF_MAGIC(NODE)		((NODE)->magic)
#define EOBJECTREF_UIDX(NODE)		((NODE)->uidx)
#define	EOBJECTREF_DTABLE(NODE)		((NODE)->dtable)
#define	EOBJECTREF_MUTEX(NODE)		((NODE)->mutex)
#define	EOBJECTREF_DTABLE_OFFSET	((int) &(*(eobjectref_t *) 0).dtable)
#define EOBJECTREF_ENV(NODE)		(DISPATCH_ENV (EOBJECTREF_DTABLE ((eobjectref_t *) NODE)))

/** 
    environment  ϰ ִ Object Ref   Ʒ .

   Object Ref  

   <pre>
   +-----------------+
   | dtable          +----> dispatch table
   +-----------------+
   | mutex           |
   +-----------------+
   | fields 1        |
   +-----------------+
   | fields ...      |
   +-----------------+
   | fields n        |
   +-----------------+
   </pre>

   fields  ,   object   field    
   Ѵ.   ⿡ field  Ǵ ̴.   fields  
   ENV_FIELDS_SIZE_IN_BYTE ũο  ȴ.  
*/
struct eobjectref
{
  /* For Debuggging.  */
  unsigned int magic;	/*  0xacacacac  */

  /** ObjectRef  Unique Idx.  */
  EREF_UNIQUE_IDX_TYPE uidx;

  /** Environment  dispatch table ν, environment   method 
       Լ ͵ Ǿ ִ.  */
  struct dispatch_table *dtable;

  apr_thread_mutex_t *mutex;
  /** Data follows on immediately */
};

#define EARRAYREF_UIDX(NODE)		((NODE)->uidx)

/**
   Number of elements. 
*/
#define	EARRAYREF_MAGIC(NODE)		(((earrayref_t *) (NODE))->magic)
#define EARRAYREF_TYPE(NODE)		(((earrayref_t *) (NODE))->type)
#define	EARRAYREF_SIZE(NODE)		(((earrayref_t *) (NODE))->length)
#define	EARRAYREF_DATA(NODE)		((void *)&(((earrayref_t *) (NODE))->data))
#define	EARRAYREF_SIZE_OFFSET		((int) &EARRAYREF_SIZE (0))
#define	EARRAYREF_DATA_OFFSET		((int) EARRAYREF_DATA (0))

/**
   ü earray  ,  arrayref (VM  Ǵ array reference object)  
   Ÿ , ȴ.  
*/
struct earrayref
{
  /* For Debuggging.  */
  unsigned int magic;	/*  0xbdbdbdbd  */

  /* ArrayRef  Unique Idx.  ̰ EARRAYREF Splay Tree  ϵ 
     ü ã  ȴ.  */
  EREF_UNIQUE_IDX_TYPE uidx;

  /* ArrayRef  type.  */
  etype_t *type;

  /**  array  .  */
  unsigned int length; 
  union 
  { 
    eboolean_t	v_boolean[1];		/** array_of_boolean */
    ebyte_t	v_byte[1];		/** array_of_byte */
    echar_t	v_char[1];		/** array_of_char */
    edouble_t	v_double[1];		/** array_of_double */
    efloat_t	v_float[1];		/** array_of_float */
    eint_t	v_int[1];		/** array_of_int */
    eshort_t	v_short[1];		/** array_of_short */
    elong_t	v_long[1];		/** array_of_long */
    eobjectref_t *v_object[1];		/** array_of_object */
    earrayref_t *v_array[1];		/** array_of_array */
  } data[1];
};

/**
   VM   reference  Ÿ ü.

   TODO:  ϼ ʾҴ.
*/
union erefs_def
{
  struct ecommonref ec;
  struct eobjectref eo;
  struct earrayref ea;
};

#define ENV_ABORT()	env_abort ()

/**  Լ Environment     ü ʱȭѴ.  */
extern int e_init_main (apr_pool_t *, apr_pool_t *, apr_pool_t *, server_rec *);

#endif	/* ENV_H */
