/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ENV_TYPES_H
#define ENV_TYPES_H

#ifdef __GNUC__

/* If we're using gcc, we can use a platform-independent scheme to get
   the right integer types.  FIXME: this is not always correct, for
   instance on the c4x it will be wrong -- it depends on whether
   QImode is 8 bits.  */
typedef int    ebyte_t  __attribute__((__mode__(__QI__)));
typedef int    eshort_t __attribute__((__mode__(__HI__)));
typedef int    eint_t   __attribute__((__mode__(__SI__)));
typedef int    elong_t  __attribute__((__mode__(__DI__)));
typedef int    eboolean_t __attribute__((__mode__(__QI__)));
typedef unsigned short echar_t __attribute__((__mode__(__HI__)));
typedef float  efloat_t;
typedef double edouble_t;

#else	/* __GNUC__ */

typedef char		ebyte_t;
typedef short		eshort_t;

#if SIZEOF_INT == 4
typedef int		eint_t;
#elif SIZEOF_LONG == 4
typedef long		eint_t;
#else
#error "sizeof(int) or sizeof(long) must be 4"
#endif

#if SIZEOF_LONG == 8
typedef long		elong_t;
#elif SIZEOF_LONG_LONG == 8
typedef long long	elong_t;
#elif SIZEOF___INT64 == 8
typedef __int64		elong_t;
#else
#error "sizeof(long long) or sizeof(__int64) must be 8"
#endif

typedef float		efloat_t;
typedef double		edouble_t;
typedef unsigned short	echar_t;
typedef char		eboolean_t;

#endif	/* __GNUC__ */

typedef	void *		eref_t;
typedef eref_t		estring_t;

#endif	/* ENV_TYPES_H */
