/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ENV_LOG_H
#define ENV_LOG_H

#define	ENVLOG_EMERG		0	/* system is unusable */
#define	ENVLOG_ALERT		1	/* action must be taken immediately */
#define	ENVLOG_CRIT		2	/* critical conditions */
#define	ENVLOG_ERR		3	/* error conditions */
#define	ENVLOG_WARNING		4	/* warning conditions */
#define	ENVLOG_NOTICE		5	/* normal but significant condition */
#define	ENVLOG_INFO		6	/* informational */
#define	ENVLOG_DEBUG		7	/* debug-level messages */

#define	ENVLOG_LEVELMASK		7	/* mask off the level value */

#ifndef DEFAULT_ENVLOGLEVEL
#define DEFAULT_ENVLOGLEVEL	ENVLOG_DEBUG
#endif

#define ENVLOG_NOERRNO		(ENVLOG_LEVELMASK + 1)
#define ENVLOG_MARK		__FILE__,__LINE__

extern void env_log_error (const char *, int, int, const char *, ...);
extern void  env_log_error_core (const char *, int, int, const char *, va_list);

#endif
