/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef MODULE_ENVIRONMENT_H
#define MODULE_ENVIRONMENT_H

#define CONTEXT_STATE(NODE)		((NODE)->state)
#define CONTEXT_REQUEST(NODE)		((NODE)->r)
#define CONTEXT_BRIGADE(NODE)		((NODE)->brigade)
#define CONTEXT_FILEINFO(NODE)		((NODE)->finfo)
#define CONTEXT_REQUEST_PROCESSED(NODE)	((NODE)->request_processed)

/* The server_context used by Environment.  */
struct eserver_context 
{
  int state;
  
  request_rec *r;
  apr_bucket_brigade *brigade;
  /* stat structure of the current file */
  struct stat finfo;
  
  /* Whether or not we've processed E in the output filters yet. */
  int request_processed;
};

typedef struct eserver_context eserver_context_t;

#endif
