/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ENV_TSRM_H
#define ENV_TSRM_H

#define TSRM_DEBUG_NOLEVEL	0

#define THREAD_T	pthread_t
#define MUTEX_T		pthread_mutex_t

#define TSRM_RESOURCE_SIZE(NODE)	((NODE)->size)
#define TSRM_RESOURCE_BUF(NODE)		((NODE)->buf)

struct tsrm_resource 
{
  size_t size;
  void *buf;
};

typedef struct tsrm_resource tsrm_resource_t;

#define TSRM_ENTRY_COUNT(NODE)		((NODE)->count)
#define TSRM_ENTRY_SLOTS(NODE)		((NODE)->buffer)
#define TSRM_ENTRY_ENTRY(NODE, IDX)	((NODE)->buffer[(IDX)])

struct tsrm_entry
{
  int count;
  struct tsrm_resource **buffer;
};

typedef struct tsrm_entry tsrm_entry_t;

extern void *tsrm_malloc (apr_pool_t *, size_t);
extern void tsrm_destory (void);
extern void *tsrm_fetch (int);

extern int init_tsrm (int, char *);
extern void finish_tsrm (void);

#endif
