/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ENV_UTIL_H
#define ENV_UTIL_H

#define MDEBUG			1
#ifdef MDEBUG
#define env_malloc(SIZE)	debug_env_malloc (SIZE)
#define env_calloc(n, SIZE)	debug_env_calloc (n, SIZE)
#define env_realloc(PTR, SIZE)	debug_env_realloc (PTR, SIZE)
#define env_free(PTR)		debug_env_free (PTR)
#else
#define env_malloc(SIZE)	malloc (SIZE)
#define env_calloc(n, SIZE)	calloc (n, SIZE)
#define env_realloc(PTR, SIZE)	realloc (PTR, SIZE)
#define env_free(PTR)		free (PTR)
#endif

extern char * url_encode (char *, int, int *);
extern int url_decode (char *, int);

extern void warning (const char *, ...);
extern void error (const char *, ...);

/* String.  */
extern char * env_strdup (const char *);
extern char * env_strndup (const char *, uint);
extern char * env_subst (const char *, int, const char *, int, int, const char *);

/* Floating Pointer.  */
extern int env_cvtdi (double);
extern long long env_cvtdl (double);
extern long long env_cvtfl (float);
extern int env_cvtfi (float);
extern int env_fcmpg (float, float);
extern int env_fcmpl (float, float);
extern int env_dcmpg (double, double);
extern int env_dcmpl (double, double);

/* ޸ Ҵ κ Լ.  */
extern void *debug_env_malloc (size_t);
extern void *debug_env_calloc (size_t, size_t);
extern void *debug_env_realloc (void *, size_t);
extern void debug_env_free (void *);

#endif
