/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef VM_H
#define VM_H

/* Autoconf config.h.  */
#undef PACKAGE
#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION

#include "config.h"

/* C Standard Header.  */
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <setjmp.h>

/* 
   Apache  ϴ header.  
 */
#include "apr_sha1.h"
#include "apr_base64.h"

/* 
   Apache   Environment Module  header.  
*/
#include <ansidecl.h>
#include "hex.h"
#include "system.h"
#include "mod_e.h"
#include "tsrm.h"

/* 
    Ǵ ̺귯  header.  
*/

#include "vm_config.h"
#ifdef USE_GC
#include "gc.h"
#include "private/gc_priv.h"
#include "gc_mark.h"
#endif
#include "util.h"
#include "vm_hashtab.h"
#include "vm_splay-tree.h"
#include "safe-ctype.h"

#include "llist.h"
#include "qsort.h"
#include "log.h"

/*
  Environment  header.
*/
#include "etype.h"
#include "ekey.h"
#include "euri.h"
#include "efile.h"
#include "env.h"
#include "eref.h"
#include "egc.h"

/* 
   VM  ̺귯 header.  
*/
#include "gc.h"
#include "call.h"
#include "vm_common.h"
/* vm_scoreboard.h  scoreboard.h Ͽ κ Ѵ.  ׷ 
    ؼ ݵ  scoreboard.h  include ؾ Ѵ.  */
#include "vm_scoreboard.h"
#include "vm_icode.h"

/*
  Request  ̺귯 header.
*/
#include "request.h"

#include "eserver.h"
#include "loader.h"

/* TREE   header .  */
#include "config/i386.h"
#include "hwint.h"
#include "machmode.h"
#include "etree.h"
#include "fold-const.h"
#include "stor-layout.h"

#include "econf.h"

#endif
