/*  -
   Copyright (C) 2005 Weongyo Jeong (weongyo@gmail.com)

This file is part of eserver.

eserver is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

eserver is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef EVM_ICODE_H
#define EVM_ICODE_H

#define	add_double(t, f1, f2)			(t)[0].v.edouble = (f1)[0].v.edouble + (f2)[0].v.edouble
#define	add_float(t, f1, f2)			(t)[0].v.efloat = (f1)[0].v.efloat + (f2)[0].v.efloat
#define	add_int(t, f1, f2)			(t)[0].v.eint = ((f1)[0].v.eint) + ((f2)[0].v.eint)
#define	add_int_const(t, f, c)			(t)[0].v.eint = ((f)[0].v.eint) + (c)
#define	add_long(t, f1, f2)			(t)[0].v.elong = (f1)[0].v.elong + (f2)[0].v.elong
#define	add_ref(t, f1, f2)			(t)[0].v.eaddr = (void*)((unsigned char *)((f1)[0].v.eaddr) + ((f2)[0].v.eint))
#define	add_ref_const(t, f, c)			(t)[0].v.eaddr = (void*)((unsigned char *)((f)[0].v.eaddr) + (c))

#define	and_int(t, f1, f2)			(t)[0].v.eint = ((f1)[0].v.eint) & ((f2)[0].v.eint)
#define	and_long(t, f1, f2)			(t)[0].v.elong = (f1)[0].v.elong & (f2)[0].v.elong

#define	ashr_int(t, f1, f2)			(t)[0].v.eint = ((int)(f1)[0].v.eint) >> ((f2)[0].v.eint & 31)
#define	ashr_long(t, f1, f2)			(t)[0].v.elong = ((long long)(f1)[0].v.elong) >> ((f2)[0].v.eint & 63)

#define	branch_a(w)				w
#define	branch_indirect(w)			w

#define	call(m)					process_env (method_class(), 1); \
						run_vm ((emethod_t *) (m)[0].v.eaddr, ret, sp+1)
#define	call_indirect_method(m)			process_env (method_class(), 1); \
						run_vm (m, ret, sp+1)
#define	call_indirect_method_skip_objectref(m)	process_env (method_class(), 1); \
						run_vm (m, ret, sp+2)

#define	cbranch_int_eq(s1, s2, w)		if ((s1)[0].v.eint == (s2)[0].v.eint) w
#define	cbranch_int_ne(s1, s2, w)		if ((s1)[0].v.eint != (s2)[0].v.eint) w
#define	cbranch_int_lt(s1, s2, w)		if ((s1)[0].v.eint < (s2)[0].v.eint) w
#define	cbranch_int_le(s1, s2, w)		if ((s1)[0].v.eint <= (s2)[0].v.eint) w
#define	cbranch_int_gt(s1, s2, w)		if ((s1)[0].v.eint > (s2)[0].v.eint) w
#define	cbranch_int_ge(s1, s2, w)		if ((s1)[0].v.eint >= (s2)[0].v.eint) w
#define	cbranch_int_ult(s1, s2, w)		if ((unsigned int)(s1)[0].v.eint < (unsigned int)(s2)[0].v.eint) w

#define	cbranch_int_const_eq(s1, s2, w)		if ((s1)[0].v.eint == (s2)) w
#define	cbranch_int_const_ne(s1, s2, w)		if ((s1)[0].v.eint != (s2)) w
#define	cbranch_int_const_lt(s1, s2, w)		if ((s1)[0].v.eint < (s2)) w
#define	cbranch_int_const_le(s1, s2, w)		if ((s1)[0].v.eint <= (s2)) w
#define	cbranch_int_const_gt(s1, s2, w)		if ((s1)[0].v.eint > (s2)) w
#define	cbranch_int_const_ge(s1, s2, w)		if ((s1)[0].v.eint >= (s2)) w
#define	cbranch_int_const_ult(s1, s2, w)	if ((unsigned int)(s1)[0].v.eint < (unsigned int)(s2)) w

#define cbranch_ref_eq(s1, s2, w)		if ((s1)[0].v.eaddr == (s2)[0].v.eaddr) w
#define cbranch_ref_ne(s1, s2, w)		if ((s1)[0].v.eaddr != (s2)[0].v.eaddr) w
#define cbranch_ref_const_eq(s1, s2, w)		if ((s1)[0].v.eaddr == (void*)(s2)) w
#define cbranch_ref_const_ne(s1, s2, w)		if ((s1)[0].v.eaddr != (void*)(s2)) w

#define	cmpg_float(t, f1, f2)			(t)[0].v.eint = env_fcmpg((f1)[0].v.efloat, (f2)[0].v.efloat)
#define	cmpg_double(t, f1, f2)			(t)[0].v.eint = env_dcmpg((f1)[0].v.edouble, (f2)[0].v.edouble)
#define	cmpl_float(t, f1, f2)			(t)[0].v.eint = env_fcmpl((f1)[0].v.efloat, (f2)[0].v.efloat)
#define	cmpl_double(t, f1, f2)			(t)[0].v.eint = env_dcmpl((f1)[0].v.edouble, (f2)[0].v.edouble)

#define	cvt_double_int(t, f)			(t)[0].v.eint = env_cvtdi ((f)[0].v.edouble)
#define	cvt_double_long(t, f)			(t)[0].v.elong = env_cvtdl ((f)[0].v.edouble)
#define	cvt_double_float(t, f)			(t)[0].v.efloat = (f)[0].v.edouble
#define	cvt_float_int(t, f)			(t)[0].v.eint = env_cvtfi ((f)[0].v.efloat)
#define	cvt_float_double(t, f)			(t)[0].v.edouble = (f)[0].v.efloat
#define	cvt_float_long(t, f)			(t)[0].v.elong = env_cvtfl ((f)[0].v.efloat)
#define	cvt_int_byte(t, f)			(t)[0].v.eint = (((f)[0].v.eint) << 24) >> 24
#define	cvt_int_char(t, f)			(t)[0].v.eint = ((f)[0].v.eint) & 0xFFFF
#define	cvt_int_double(t, f)			(t)[0].v.edouble = (f)[0].v.eint
#define	cvt_int_float(t, f)			(t)[0].v.efloat = (f)[0].v.eint
#define	cvt_int_long(t, f)			(t)[0].v.elong = (f)[0].v.eint
#define	cvt_int_short(t, f)			(t)[0].v.eint = (((f)[0].v.eint) << 16) >> 16
#define	cvt_long_int(t, f)			(t)[0].v.eint = (f)[0].v.elong
#define	cvt_long_float(t, f)			(t)[0].v.efloat = (f)[0].v.elong
#define	cvt_long_double(t, f)			(t)[0].v.edouble = (f)[0].v.elong

#define	div_double(t, f1, f2)			(t)[0].v.edouble = (f1)[0].v.edouble / (f2)[0].v.edouble
#define	div_float(t, f1, f2)			(t)[0].v.efloat = (f1)[0].v.efloat / (f2)[0].v.efloat
#define div_int(t, f1, f2)			(t)[0].v.eint = ((((f2)[0].v.eint) != -1) ? (((f1)[0].v.eint) / ((f2)[0].v.eint)) : -((f1)[0].v.eint))
#define	div_long(t, f1, f2)			(t)[0].v.elong = (f1)[0].v.elong / (f2)[0].v.elong

#define	lcmp(t, f1, f2)				lcc = ((f2)[0].v.elong) - ((f1)[0].v.elong); \
						(t)[0].v.eint = (lcc < 0 ? -1 : lcc > 0 ? 1 : 0)

#define	load_code_ref				load_key

#define load_field_byte(t, f, o)		((t)[0].v.ebyte) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.ebyte
#define load_field_char(t, f, o)		((t)[0].v.echar) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.echar
#define load_field_double(t, f, o)		((t)[0].v.edouble) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.edouble
#define load_field_float(t, f, o)		((t)[0].v.efloat) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.efloat
#define load_field_int(t, f, o)			((t)[0].v.eint) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.eint
#define load_field_long(t, f, o)		((t)[0].v.elong) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.elong
#define load_field_ref(t, f, o)			((t)[0].v.eaddr) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.eaddr
#define load_field_short(t, f, o)		((t)[0].v.eshort) = ((evalue_t *)((unsigned char *)(f)[0].v.eaddr + (o)))[0].v.eshort

#define	load_key(t, f)				(t)[0].v.eint = \
						 ((((unsigned char *)(f)->v.eaddr)[0] << 24) | \
						 (((unsigned char *)(f)->v.eaddr)[1] << 16) | \
						 (((unsigned char *)(f)->v.eaddr)[2] << 8) | \
						 ((unsigned char *)(f)->v.eaddr)[3])

#define	load_offset_int(t, f, o)		(t)[0].v.eint = *(eint_t *) ((unsigned char *) (f)[0].v.eaddr + (o))
#define	load_offset_ref(t, f, o)		(t)[0].v.eaddr = *(void **) ((unsigned char *) (f)[0].v.eaddr + (o))

#define	load_offset_scaled_int(t, b, i, o)	(t)[0].v.eint = ((int *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]
#define	load_offset_scaled_byte(t, b, i, o)	(t)[0].v.eint = ((char *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]
#define	load_offset_scaled_char(t, b, i, o)	(t)[0].v.eint = ((char *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]
#define	load_offset_scaled_short(t, b, i, o)	(t)[0].v.eint = ((short *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]
#define	load_offset_scaled_ref(t, b, i, o)	(t)[0].v.eaddr = ((void**)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]
#define	load_offset_scaled_long(t, b, i, o)	(t)[0].v.elong = ((long long *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]
#define	load_offset_scaled_float(t, b, i, o)	(t)[0].v.efloat = ((float *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]
#define	load_offset_scaled_double(t, b, i, o)	(t)[0].v.edouble = ((double*)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint]

#define load_static_int(t, f)			(t)[0].v.eint = (f).v.ebyte
#define load_static_byte(t, f)			(t)[0].v.ebyte = (f).v.echar
#define load_static_char(t, f)			(t)[0].v.echar = (f).v.echar
#define load_static_short(t, f)			(t)[0].v.eshort = (f).v.eshort
#define load_static_ref(t, f)			(t)[0].v.eaddr = (f).v.eaddr
#define load_static_long(t, f)			(t)[0].v.elong = (f).v.elong
#define load_static_float(t, f)			(t)[0].v.efloat = (f).v.efloat
#define load_static_double(t, f)		(t)[0].v.edouble = (f).v.edouble

#define	lshl_int(t, f1, f2)			(t)[0].v.eint = ((f1)[0].v.eint) << ((f2)[0].v.eint & 31)
#define	lshl_int_const(t, f, c)			(t)[0].v.eint = ((f)[0].v.eint) << (c & 31)
#define	lshl_long(t, f1, f2)			(t)[0].v.elong = ((f1)[0].v.elong) << ((f2)[0].v.eint & 63)
#define	lshr_int(t, f1, f2)			(t)[0].v.eint = ((unsigned int)(f1)[0].v.eint) >> ((f2)[0].v.eint & 31)
#define	lshr_long(t, f1, f2)			(t)[0].v.elong = ((unsigned long long)(f1)[0].v.elong) >> ((f2)[0].v.eint & 63)

#define	move_any(t, f)				move_long (t, f)
#define	move_double(t, f)			(t)[0].v.edouble = (f)[0].v.edouble
#define	move_double_const(t, c)			(t)[0].v.edouble = (c)
#define	move_float(t, f)			(t)[0].v.efloat = (f)[0].v.efloat
#define	move_float_const(t, c)			(t)[0].v.efloat = (c)
#define	move_ref(t, f)				(t)[0].v.eaddr = (f)[0].v.eaddr
#define	move_ref_const(t, c)			(t)[0].v.eaddr = (void*) (c)
#define	move_int(t, f)				(t)[0].v.eint = (f)[0].v.eint
#define	move_int_const(t, c)			(t)[0].v.eint = (c)
#define	move_label_const(t, c)			move_ref_const(t, c)
#define	move_long(t, f)				(t)[0].v.elong = (f)[0].v.elong
#define	move_long_const(t, c)			(t)[0].v.elong = (c)
#define	move_string_const(t, c)			move_ref_const(t, c)

#define	mul_double(t, f1, f2)			(t)[0].v.edouble = ((f1)[0].v.edouble * (f2)[0].v.edouble)
#define	mul_float(t, f1, f2)			(t)[0].v.efloat = ((f1)[0].v.efloat * (f2)[0].v.efloat)
#define	mul_int(t, f1, f2)			(t)[0].v.eint = ((f1)[0].v.eint) * ((f2)[0].v.eint)
#define	mul_long(t, f1, f2)			(t)[0].v.elong = ((f1)[0].v.elong * (f2)[0].v.elong)

#define	negate_double(t, f)			(t)[0].v.edouble = -(f)[0].v.edouble
#define	negate_float(t, f)			(t)[0].v.efloat = -(f)[0].v.efloat
#define	negate_int(t, f)			(t)[0].v.eint = -((f)[0].v.eint)
#define	negate_long(t, f)			(t)[0].v.elong = -(f)[0].v.elong

#define	or_int(t, f1, f2)			(t)[0].v.eint = ((f1)[0].v.eint) | ((f2)[0].v.eint)
#define	or_long(t, f1, f2)			(t)[0].v.elong = (f1)[0].v.elong | (f2)[0].v.elong

#define	reference_code_label(l)			npc = (l)
#define	reference_label(i, l)			goto label##i##l
#define	reference_table_label(l)		&code[npc]

#define rem_long(t, f1, f2)			(t)[0].v.elong = (((f2)[0].v.elong != -1) ? ((f1)[0].v.elong % (f2)[0].v.elong) : 0)
#define rem_int(t, f1, f2)			(t)[0].v.eint = ((((f2)[0].v.eint) != -1) ? (((f1)[0].v.eint) % ((f2)[0].v.eint)) : 0)
#define	rem_float(t, f1, f2)			(t)[0].v.efloat = fmodf ((f1)[0].v.efloat, (f2)[0].v.efloat)
#define	rem_double(t, f1, f2)			(t)[0].v.edouble = fmod ((f1)[0].v.edouble, (f2)[0].v.edouble)

#define	return_int(s)				(s)[0].v.eint = ret[0].v.eint
#define	return_long(s)				(s)[0].v.elong = ret[0].v.elong
#define	return_float(s)				(s)[0].v.efloat = ret[0].v.efloat
#define	return_double(s)			(s)[0].v.edouble = ret[0].v.edouble
#define	return_ref(s)				(s)[0].v.eaddr = ret[0].v.eaddr

#define	returnarg_int(s)			ret[0].v.eint = (s)[0].v.eint
#define	returnarg_ref(s)			ret[0].v.eaddr = (s)[0].v.eaddr
#define	returnarg_long(s)			ret[0].v.elong = (s)[0].v.elong
#define	returnarg_float(s)			ret[0].v.efloat = (s)[0].v.efloat
#define	returnarg_double(s)			ret[0].v.edouble = (s)[0].v.edouble

#define	ret()					goto end

#define	set_label(i, l)				label##i##l:

#define	softcall_anewarray(r, s, t)		(r)->v.eaddr = new_anewarray (t, (s)->v.eint)
#define	softcall_athrow(s)			soft_athrow ((s)[0].v.eaddr)
#define	softcall_breakpoint()			ENV_ABORT ()
#define	softcall_checkcast(n, o, t)		soft_checkcast (t, (o)->v.eaddr)
#define softcall_initialise_class(cl)		soft_initialise_class (cl)
#define	softcall_instanceof(r, o, t)		(r)->v.eint = soft_instanceof (t, (o)->v.eaddr)
#define	softcall_lookupinterfacemethod(r, n, t)	(r)[0].v.eaddr = lookup_interfacemethod ((t)[0].v.eaddr, METHOD_ENV (n), METHOD_INDEX (n))
#define	softcall_multianewarray(r, z, s, t)	(r)->v.eaddr = soft_multianewarray (t, z, s); \
						POP ((z) - 1)
/* Thread.stop() knows how to back out of java frames, so we do not
 * want to disable stop here
 */
#define	softcall_monitorenter(o)		lock_eobjectref ((o)[0].v.eaddr)
#define	softcall_monitorexit(o)			unlock_eobjectref ((o)[0].v.eaddr)
#define	softcall_new(r, t)			(r)->v.eaddr = new_objectref ((t))
#define	softcall_newarray(r, s, t)		(r)->v.eaddr = new_arrayref (get_etype_with_kind ((t)), (s)->v.eint)
#define	softcall_nullpointer()			soft_nullpointer ()

#define store_field_byte(t, o, f)		((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.ebyte = ((f)[0].v.ebyte)
#define store_field_char(t, o, f)		((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.echar = ((f)[0].v.echar)
#define store_field_double(t, o, f)	        ((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.edouble = ((f)[0].v.edouble)
#define store_field_float(t, o, f)		((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.efloat = ((f)[0].v.efloat)
#define store_field_int(t, o, f)		((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.eint = ((f)[0].v.eint)
#define store_field_long(t, o, f)		((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.elong = ((f)[0].v.elong)
#define store_field_ref(t, o, f)		((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.eaddr = ((f)[0].v.eaddr)	
#define store_field_short(t, o, f)		((evalue_t *)((unsigned char *)(t)[0].v.eaddr + (o)))[0].v.eshort = ((f)[0].v.ebyte)

#define	store_offset_int(t, o, f)		*(int *)((unsigned char *)(t)[0].v.eaddr + (o)) = ((f)[0].v.eint)

#define	store_offset_scaled_int(b, i, o, f)	((int *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.eint)
#define	store_offset_scaled_byte(b, i, o, f)	((char *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.eint)
#define	store_offset_scaled_char(b, i, o, f)	((char *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.eint)
#define	store_offset_scaled_short(b, i, o, f)	((short *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.eint)
#define	store_offset_scaled_ref(b, i, o, f)	((void **)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.eaddr)
#define	store_offset_scaled_long(b, i, o, f)	((long long *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.elong)
#define	store_offset_scaled_float(b, i, o, f)	((float *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.efloat)
#define	store_offset_scaled_double(b, i, o, f)	((double *)((unsigned char *)(b)[0].v.eaddr + (o)))[(i)[0].v.eint] = ((f)[0].v.edouble)

#define store_static_int(t, f)			(t).v.ebyte = (f)[0].v.eint
#define store_static_byte(t, f)			(t).v.echar = (f)[0].v.ebyte
#define store_static_char(t, f)			(t).v.echar = (f)[0].v.echar
#define store_static_short(t, f)		(t).v.eshort = (f)[0].v.eshort
#define store_static_ref(t, f)			(t).v.eaddr = (f)[0].v.eaddr
#define store_static_long(t, f)			(t).v.elong = (f)[0].v.elong
#define store_static_float(t, f)		(t).v.efloat = (f)[0].v.efloat
#define store_static_double(t, f)		(t).v.edouble = (f)[0].v.edouble

#define	stored_code_label(l)			npc = (l)[0].v.eint

#define	sub_double(t, f1, f2)			(t)[0].v.edouble = (f1)[0].v.edouble - (f2)[0].v.edouble
#define	sub_float(t, f1, f2)			(t)[0].v.efloat = (f1)[0].v.efloat - (f2)[0].v.efloat
#define	sub_int(t, f1, f2)			(t)[0].v.eint = ((f1)[0].v.eint) - ((f2)[0].v.eint)
#define	sub_int_const(t, f, c)			(t)[0].v.eint = ((f)[0].v.eint) - (c)
#define	sub_long(t, f1, f2)			(t)[0].v.elong = (f1)[0].v.elong - (f2)[0].v.elong

#define	swap_any(t1, t2)	\
  {				\
    tmp[0] = (t1)[0];		\
    (t1)[0] = (t2)[0];		\
    (t2)[0] = tmp[0];		\
  }

#define	table_code_label(l)			npc = (l)[0].v.eint + pc

#define	xor_int(t, f1, f2)			(t)[0].v.eint = ((f1)[0].v.eint) ^ ((f2)[0].v.eint)
#define	xor_long(t, f1, f2)			(t)[0].v.elong = (f1)[0].v.elong ^ (f2)[0].v.elong

#endif
