#ifndef ESM_ESM_H
#define ESM_ESM_H

/* Eserver  ⺻ port .   eserver  , random Ʈ 
    Ư , default port   ϱ , ⿡ ӽγ
    д.  */
#define DEFAULT_ESERVER_PORT		8889

/* Label  operation   ü.  */
struct labels
{
  /* Label ̸ */
  tree name;

  /* Label  ġ ڵ position.  */
  int code_offset;

  struct labels *next;
};

#define ENVIRON_ADDRESS_REF_PREFIX	"e://"
#define ENVIRON_ADDRESS_REF_PREFIX_LEN	4

/* essembly  Ǵ instruction 鿡     
   ⼭  д.  */
enum insn_code
  {
#define DEF_CODE(ENUM, NAME, NUMBER, FORMAT, CLASS, OPLEN)   ENUM ,
#include "code.def"
#undef DEF_CODE
    NUM_INSN_CODE
  };

enum esm_ttype
  {
#define DEF_TOKEN(ENUM, NAME)   ENUM ,
#include "token.def"
#undef DEF_TOKEN
    NUM_TOKEN_CODE
  };

enum esm_access
  {
    ACC_PUBLIC = 1,
    ACC_PRIVATE = 2,
    ACC_PROTECTED = 4,
    ACC_STATIC = 8,
    ACC_FINAL = 16,
    ACC_SYNCHRONIZED = 32,
    ACC_VOLATILE = 64,
    ACC_TRANSIENT = 128,
    ACC_NATIVE = 256,
    ACC_INTERFACE = 512,
    ACC_ABSTRACT = 1024,
    ACC_SUPER = 32
  };

enum constant
  {
    CONSTANT_Unknown		= 0,
    CONSTANT_Utf8		= 1,
    CONSTANT_Integer		= 3,
    CONSTANT_Float		= 4,
    CONSTANT_Long		= 5,
    CONSTANT_Double		= 6,
    CONSTANT_Environment	= 7,
    CONSTANT_String		= 8,
    CONSTANT_Fieldref		= 9,
    CONSTANT_Methodref		= 0xA,
    CONSTANT_InterfaceMethodref = 0xB,
    CONSTANT_NameAndType	= 0xC,
    /* Access Flag   .  */
    CONSTANT_Accessref		= 0x10,
    /*   environment  SHA1  Ų.  */
    CONSTANT_Sha1This		= 0x11,
    /* ش SHA1   ִ.  */
    CONSTANT_Sha1		= 0x12,
    CONSTANT_Sha1AndName	= 0x13,
    CONSTANT_Host		= 0x14
  };

#define CONSTANT_INDEX(CP)		((CP)->index)
#define CONSTANT_TYPE(CP)		((CP)->type)
#define CONSTANT_NEXT(CP)		((CP)->next)
#define CONSTANT_VARG0(CP)		((CP)->value.args[0])
#define CONSTANT_VARG1(CP)		((CP)->value.args[1])
#define CONSTANT_INTEGER_VALUE_ARG0(CP)	((CP)->value.args[0])
#define CONSTANT_INTEGER_VALUE_ARG1(CP)	((CP)->value.args[1])
#define CONSTANT_LONG_VALUE_ARG0(CP)	((CP)->value.largs[0])
#define CONSTANT_LONG_VALUE_ARG1(CP)	((CP)->value.largs[1])
#define CONSTANT_VSTRING(CP)		((CP)->value.string)

struct constant_pool
{
  /*  constant   unique number   ִ.  */
  int index;

  /*  constant   type  Ѵ.  */
  enum constant type;
  union 
  {
    HOST_WIDE_INT args[2];
    long largs[2];
    char *string;
  } value;

  struct constant_pool *next;
};

/* .package "eng.lang"  eng.lang  eng/lang/   θ 
   .  */
extern char *package_path;

/*  óϰ ִ environment  ̸  ִ.  */
extern tree current_envname;

extern int line;

extern int esm_lexer (tree *);
extern int finish_program (tree);
extern int process_match (tree);
extern int constant_process (enum constant, tree);
extern int count_access_hosts (tree);
extern int count_fields (tree);
extern int count_methods (tree);
extern int count_insn_length (tree);
extern int count_max_stack (tree, int);
extern int count_max_locals (tree, tree);
extern int count_attribute (tree);
extern int cp_add (enum constant, ...);
extern void process_insn (tree);
extern void check_reserved_method (tree);
extern int add_label (struct labels **, tree, int);
extern const char * esm_type2name (enum esm_ttype);
extern int calculate_switch (tree, int);

#endif
