#include "eas.h"
#include "machmode.h"
#include "tree.h"
#include "stringpool.h"
#include "esm.h"
#include "system.h"
#include "sha1.h"
#include "real.h"
#include "stor-layout.h"

#ifndef MAX_FIXED_MODE_SIZE
#define MAX_FIXED_MODE_SIZE GET_MODE_BITSIZE (DImode)
#endif

/* bit ũ precision  Ͽ TYPE    ϰ,
   ׷  װ ̾ƿѴ.  Tree code  INTEGER_TYPE  ƴϱ
    make_signed_type      ȴ.
    , Pascal  -fsigned-char option  ־ 
   ȴ.  */

void
fixup_signed_type (type)
     tree type;
{
  int precision = TYPE_PRECISION (type);

  /* i386 vector extension   ģ鿡  ǰ 
     type  ʿ Ҷ 2 * HOST_BITS_PER_WIDE_INT 
     ū   ǥ  .  */
  if (precision > HOST_BITS_PER_WIDE_INT * 2)
    precision = HOST_BITS_PER_WIDE_INT * 2;

  TYPE_MIN_VALUE (type)
    = build_int_2 ((precision - HOST_BITS_PER_WIDE_INT > 0
		    ? 0 : (HOST_WIDE_INT) (-1) << (precision - 1)),
		   (((HOST_WIDE_INT) (-1)
		     << (precision - HOST_BITS_PER_WIDE_INT - 1 > 0
			 ? precision - HOST_BITS_PER_WIDE_INT - 1
			 : 0))));
  TYPE_MAX_VALUE (type)
    = build_int_2 ((precision - HOST_BITS_PER_WIDE_INT > 0
		    ? -1 : ((HOST_WIDE_INT) 1 << (precision - 1)) - 1),
		   (precision - HOST_BITS_PER_WIDE_INT - 1 > 0
		    ? (((HOST_WIDE_INT) 1
			<< (precision - HOST_BITS_PER_WIDE_INT - 1))) - 1
		    : 0));

  TREE_TYPE (TYPE_MIN_VALUE (type)) = type;
  TREE_TYPE (TYPE_MAX_VALUE (type)) = type;

  /* type  ̾ƿ Ѵ: ̰ alignment, size, Ÿ Ѵ.  */
  layout_type (type);
}

/* bit ũ precision  Ͽ TYPE    ϰ,
   ׷  װ ̾ƿѴ.  ̰ `make_unsigned_type' 
    enumeral type   ȴ.  */

void
fixup_unsigned_type (type)
     tree type;
{
  int precision = TYPE_PRECISION (type);

  /* i386 vector extension   ģ鿡  ǰ 
     type  ʿ Ҷ 2 * HOST_BITS_PER_WIDE_INT 
     ū   ǥ  .  */
  if (precision > HOST_BITS_PER_WIDE_INT * 2)
    precision = HOST_BITS_PER_WIDE_INT * 2;

  TYPE_MIN_VALUE (type) = build_int_2 (0, 0);
  TYPE_MAX_VALUE (type)
    = build_int_2 (precision - HOST_BITS_PER_WIDE_INT >= 0
		   ? -1 : ((HOST_WIDE_INT) 1 << precision) - 1,
		   precision - HOST_BITS_PER_WIDE_INT > 0
		   ? ((unsigned HOST_WIDE_INT) ~0
		      >> (HOST_BITS_PER_WIDE_INT
			  - (precision - HOST_BITS_PER_WIDE_INT)))
		   : 0);
  TREE_TYPE (TYPE_MIN_VALUE (type)) = type;
  TREE_TYPE (TYPE_MAX_VALUE (type)) = type;

  /* type  ̾ƿ Ѵ: ̰ alignment, size, Ÿ Ѵ.  */
  layout_type (type);
}

/* PRECISION bit  signed   type  Ͽ ȯѴ.  */

tree
make_signed_type (precision)
     int precision;
{
  tree type = make_node (INTEGER_TYPE);

  TYPE_PRECISION (type) = precision;

  fixup_signed_type (type);

  return type;
}

/* PRECISION bit  unsigned   type  Ͽ ȯѴ.  */

tree
make_unsigned_type (precision)
     int precision;
{
  tree type = make_node (INTEGER_TYPE);

  TYPE_PRECISION (type) = precision;

  fixup_unsigned_type (type);
  return type;
}

/* SIZE bit  nonscalar   machine mode  ȯ.
    mode  ݵ class CLASS   ̾ ϸ Ȯ 
   bit   Ǿ ־ Ѵ.
    LIMIT  0  ƴ϶ MAX_FIXED_MODE_SIZE   mode 
     ̴.  */

enum machine_mode
mode_for_size (size, class, limit)
     unsigned int size;
     enum mode_class class;
     int limit;
{
  enum machine_mode mode;

  if (limit && size > MAX_FIXED_MODE_SIZE)
    return BLKmode;

  /*  class   size  ó mode  ´.  */
  for (mode = GET_CLASS_NARROWEST_MODE (class); mode != VOIDmode;
       mode = GET_MODE_WIDER_MODE (mode))
    if (GET_MODE_BITSIZE (mode) == size)
      return mode;

  return BLKmode;
}

/* ,  BLKmode  ȯ ʴ´;  û bit  
     ִ   mode  ȯѴ.  */

enum machine_mode
smallest_mode_for_size (size, class)
     unsigned int size;
     enum mode_class class;
{
  enum machine_mode mode;

  /* Ư з  size  ´ ó mode   .  */
  for (mode = GET_CLASS_NARROWEST_MODE (class); mode != VOIDmode;
       mode = GET_MODE_WIDER_MODE (mode))
    if (GET_MODE_BITSIZE (mode) >= size)
      return mode;

  abort ();
}

/* TYPE   mode  size, alignment  Ѵ.
   迭 type  ؼ element   Ѵ.
   TYPE   Ȥ ӽ type     ϴµ,
   ̷ dbxout  ̰ ã ̴.

   type  TYPE_SIZE  ̹ type  ̾ƿ Ǿ   0 
   ƴ ̴. ׷  layout_type  type   ƹ͵ 
   ʴ´.

    type    ʴٸ, װ TYPE_SIZE   0
    Ǿ ִ.  */

void
layout_type (type)
     tree type;
{
  if (type == 0)
    abort ();

  /*  type   ̹ ̾ƿǾٸ ƹ͵  ʴ´.  */
  if (TYPE_SIZE (type))
    return;

  switch (TREE_CODE (type))
    {
    case INTEGER_TYPE:
      if (TREE_CODE (TYPE_MIN_VALUE (type)) == INTEGER_CST
	  && tree_int_cst_sgn (TYPE_MIN_VALUE (type)) >= 0)
	TREE_UNSIGNED (type) = 1;

      TYPE_MODE (type) = smallest_mode_for_size (TYPE_PRECISION (type),
						 MODE_INT);
      break;
    case REAL_TYPE:
      TYPE_MODE (type) = mode_for_size (TYPE_PRECISION (type), MODE_FLOAT, 0);
      break;

    default:
      warning ("layout_type: óؾ  type [%s]\n", tree_code_name[TREE_CODE (type)]);
      abort ();
    }
}
