#include "eas.h"
#include "machmode.h"
#include "tree.h"

/* ""   Ȱ ڿ.  */
const char empty_string[] = "";

#define digit_string(d) (digit_vector + ((d) * 2))

/*   ϴ Character ڿ.
    ϱ    ϴ.  */
const char digit_vector[] = {
  '0', 0, '1', 0, '2', 0, '3', 0, '4', 0,
  '5', 0, '6', 0, '7', 0, '8', 0, '9', 0
};

struct ht *ident_hash;
static struct obstack string_stack;

static hashnode alloc_node PARAMS ((hash_table *));

/* string pool  ʱȭմϴ.  */
void
init_stringpool ()
{
  tree_code_length [(int) IDENTIFIER_NODE]
    = ((sizeof (struct tree_identifier) - sizeof (struct tree_common)
	+ sizeof (tree) - 1) / sizeof (tree)) + 10000;

#if 0
  fprintf (stderr, "[StringPool] tree_code_length: IDENTIFIER_NODE = %d\n", 
	   tree_code_length [(int) IDENTIFIER_NODE]);
#endif

  /* 16K (2^14) entry  մϴ.  */
  ident_hash = ht_create (14);
  ident_hash->alloc_node = alloc_node;	/* ⼭ alloc_node  ٷ ؿ  Լ Ŵ.  */
  gcc_obstack_init (&string_stack);
}

/* hash node  Ҵմϴ.  */
static hashnode
alloc_node (table)
     hash_table *table ATTRIBUTE_UNUSED;
{
  return GCC_IDENT_TO_HT_IDENT (make_node (IDENTIFIER_NODE));
}

/* ̰ LENGTH ̰ CONTENTS  ϴ ڿ constant  ҴϿ
   ȯմϴ.  LENGTH  -1 ̸ CONTENTS  null-terminated
   ڿ մϴ. ̴ strlen  Ͽ ˴ϴ. 
    ڿ constant   ҴǾٸ  纻   
   ȯ˴ϴ.  */

const char *
ggc_alloc_string (contents, length)
     const char *contents;
     int length;
{
  if (length == -1)
    length = strlen (contents);

  if (length == 0)
    return empty_string;
  if (length == 1 && ISDIGIT (contents[0]))
    return digit_string (contents[0] - '0');

  obstack_grow0 (&string_stack, contents, length);
  return obstack_finish (&string_stack);
}

/* ̸ TEXT (NULL   ڿ)  IDENTIFIER_NODE 
   ǵݴϴ.   ̸  identifier   Ǿٸ
    node  ǵݴϴ.  */

tree
get_identifier (text)
     const char *text;
{
  hashnode ht_node = ht_lookup (ident_hash,
				(const unsigned char *) text,
				strlen (text), HT_ALLOC);

  /* ht_node  ⼭ NULL   ϴ.  */
  return HT_IDENT_TO_GCC_IDENT (ht_node);
}

/* ̰ ǵȴٴ  ϰ get_identifier Լ .  */
   
tree
get_identifier_with_length (text, length)
     const char *text;
     unsigned int length;
{
  hashnode ht_node = ht_lookup (ident_hash,
				(const unsigned char *) text,
				length, HT_ALLOC);

  /* ht_node  ⼭ NULL   ϴ.  */
  return HT_IDENT_TO_GCC_IDENT (ht_node);
}

/*  ̸ TEXT (null   ڿ)    
   ִٸ  node  ȯϰ ׷  NULL_TREE  ȯմϴ.  */

tree
maybe_get_identifier (text)
     const char *text;
{
  hashnode ht_node;

  ht_node = ht_lookup (ident_hash, (const unsigned char *) text,
		       strlen (text), HT_NO_INSERT);
  if (ht_node)
    return HT_IDENT_TO_GCC_IDENT (ht_node);

  return NULL_TREE;
}

/* String pool    ⺻ ġ report մϴ.  */

void
stringpool_statistics ()
{
  ht_dump_statistics (ident_hash);
}
