/*  .eclass   unique ID  Ѵ.
   Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004
   Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. 

Java and all Java-based marks are trademarks or registered trademarks
of Sun Microsystems, Inc. in the United States and other countries.
The Free Software Foundation is independent of Sun Microsystems, Inc.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "jcf.h"
#include "tree.h"
#include "real.h"
#include "java-tree.h"
#include "obstack.h"
#include "rtl.h"
#include "flags.h"
#include "java-opcodes.h"
#include "parse.h" /* for BLOCK_EXPR_BODY */
#include "buffer.h"
#include "toplev.h"
#include "ggc.h"
#include "tm_p.h"

#include "libetl/libetl.h"

static long ui_filesize (const char *);

static long
ui_filesize (const char *file)
{
  FILE *fp = fopen(file, "rb");
  long len = 0;

  if (fp != NULL)
    {
      if (fseek (fp, 0L, 2) != -1)
        len = ftell (fp);
      fclose (fp);
    }

  return len;
}

extern void carve_unique_id (char *);

/*   FILNAME  unique ID  .  */
void
carve_unique_id (char *filename)
{
  int len, i, size;
  char *buf, tmp[256], *tp;
  char sha1[APR_SHA1_DIGESTSIZE];
  FILE *fp;

  tp = tmp;
  len = ui_filesize (filename);
  fp = fopen (filename, "r+");

  memset (sha1, '\0', APR_SHA1_DIGESTSIZE);

  buf = (char *) xmalloc (sizeof (char) * len);
  i   = fread (buf, 1, len, fp);
  if (len != i)
    error ("carve_unique_id: error.\n");

#if UI_DEBUG
  fprintf (stderr, "Dump:\n");
  for (i=0; i<len; i++)
    {
      fprintf (stderr, "%02x", buf[i] & 0xff);
    }
  fprintf (stderr, "\n");
#endif

  apr_sha1_base64 (buf, len, tmp);
#if UI_DEBUG
  fprintf (stderr, "\ncarve_unique_id: i = %d len = %d, SHA1BASE64 ڿ : %s %d\n", i, len, tmp, buf[len - 2]);
#endif
  if (!strncmp (tp, "{SHA}", 5))
    tp += 5;
  size = apr_base64_decode_binary (sha1, tp);

  if (size != APR_SHA1_DIGESTSIZE)
    error ("carve_unique_id: ߸ SHA1 Ű .");

  (void) fseek (fp, 8L, SEEK_SET);

  for (i = 0; i < size; i++)
    {
      char tmpchar[1];
      
      tmpchar[0] = (char) sha1[i] & 0xff;
#if UI_DEBUG
      fprintf (stderr, "%02x ", tmpchar[0] & 0xff);
#endif
      fwrite (tmpchar, sizeof (char), 1, fp);
    }

  free (buf);
  fclose (fp);
}
