#ifndef ENV_KEY_H
#define ENV_KEY_H

/* 
   Environment Key.
*/

/* ENVKEY  ڿ Ͽ ,  ִ ũ.  */
#define ENVKEY_STRSIZE			256
#define ENVKEY_CHAR			char
#define ENVKEY_SIZE			APR_SHA1_DIGESTSIZE

#define GET_ENVKEY(s, e)		memcpy ((e), (s), ENVKEY_SIZE)

/**
   ENVKEY  base64  ڵ string  ־ ȯѴ.  ι°  E 
   ȯ KEY ڿ   ִ  ̿ Ѵ.  
*/
#define GET_ENVKEY_STRING(s, e)			\
	do {					\
          ENVKEY_CHAR ek[ENVKEY_SIZE];		\
          GET_ENVKEY ((s), ek);			\
          apr_base64_encode_binary (e, ek, ENVKEY_SIZE);	\
	} while (0)

#define PUT_ENVKEY(e, s)			\
	do {					\
	  memcpy ((s), (e), ENVKEY_SIZE);	\
	  if (ENVKEY_SIZE < sizeof (*s))	\
	    memset ((ENVKEY_CHAR *) (s) + ENVKEY_SIZE, 0, sizeof (*s) - ENVKEY_SIZE);	\
	} while (0)

/* Environment Key  Ѵ.  */
#define DUPLICATE_ENVKEY(s, t)			\
	do {					\
	  ENVKEY_CHAR __keychar[ENVKEY_SIZE];	\
	  (t) = (envkey_t *) env_malloc (sizeof (envkey_t));	\
	  GET_ENVKEY ((s), __keychar);		\
	  PUT_ENVKEY (__keychar, (t));		\
	} while (0)

/* Environment Key   memory pool 󿡼 Ѵ.  */
#define PDUPLICATE_ENVKEY(p, s, t)		\
	do {					\
	  ENVKEY_CHAR __keychar[ENVKEY_SIZE];	\
	  (t) = (envkey_t *) apr_pcalloc (p, (sizeof (envkey_t)));	\
	  GET_ENVKEY ((s), __keychar);		\
	  PUT_ENVKEY (__keychar, (t));		\
	} while (0)

#define FREE_ENVKEY(n)			env_free ((n));

/* Environment Key Type.  */
struct envkeystruct
{
  ENVKEY_CHAR s[ENVKEY_SIZE];
};

typedef struct envkeystruct envkey_t;

static inline int compare_envkey (envkey_t *, envkey_t *);

/* Environment Key   Ͽ   , 0  ȯϰ ׷  
   1 Ȥ -1  ȯѴ.  */
static inline int
compare_envkey (s1, s2)
     envkey_t *s1, *s2;
{
  int __tmpi;
  ENVKEY_CHAR t1[ENVKEY_SIZE], t2[ENVKEY_SIZE];

  GET_ENVKEY (s1, t1);
  GET_ENVKEY (s2, t2);

  for (__tmpi=0; __tmpi<ENVKEY_SIZE; __tmpi++)
    {
      if ((int) t1[__tmpi] < (int) t2[__tmpi])
	return -1;
      else if ((int) t1[__tmpi] > (int) t2[__tmpi])
	return 1;
    }
  
  return 0;
}

#endif
