/* Definitions of various defaults for tm.h macros.
   Copyright (C) 1992, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004
   Free Software Foundation, Inc.
   Contributed by Ron Guilmette (rfg@monkeys.com)

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef ECLIB_DEFAULTS_H
#define ECLIB_DEFAULTS_H

#ifdef IN_GCC
# include "ansidecl.h"
#endif

#define GTY(x)  /* nothing - marker for gengtype */

#ifndef USED_FOR_TARGET

struct etx_def;
typedef struct etx_def *etx;
struct etvec_def;
typedef struct etvec_def *etvec;

#else

struct _dont_use_etx_here_;
struct _dont_use_rtvec_here_;
union _dont_use_etree_here_;
#define etx struct _dont_use_etx_here_ *
#define rtvec struct _dont_use_rtvec_here *
#define etree union _dont_use_etree_here_ *

#endif

#define obstack_chunk_alloc	((void *(*) (long)) xmalloc)
#define obstack_chunk_free	((void (*) (void *)) free)
#define OBSTACK_CHUNK_SIZE	0
#define gcc_obstack_init(OBSTACK)			\
  _obstack_begin ((OBSTACK), OBSTACK_CHUNK_SIZE, 0,	\
		  obstack_chunk_alloc,			\
		  obstack_chunk_free)

#endif  /* ! ECLIB_DEFAULTS_H */
