/* GNU C-Compiler   machine mode ǵ ; rtl.h  etree.h 
   Ե.
   Copyright (C) 1991, 1993, 1994, 1996, 1998, 1999, 2000, 2001
   Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#ifndef HAVE_ETREE_MACHINE_MODES
#define HAVE_ETREE_MACHINE_MODES

/*  machine mode   ִ enum class  ϴ. */

#define DEF_MACHMODE(SYM, NAME, TYPE, BITSIZE, SIZE, UNIT, WIDER, INNER)  SYM,

enum etree_machine_mode {
#include "machmode.def"
ETREE_MAX_MACHINE_MODE };

#undef DEF_MACHMODE

#ifndef ETREE_NUM_MACHINE_MODES
#define ETREE_NUM_MACHINE_MODES (int) ETREE_MAX_MACHINE_MODE
#endif

/* ڿ · mode MODE  ̸ ϴ.  */

extern const char * const etree_mode_name[ETREE_NUM_MACHINE_MODES];
#define ETREE_GET_MODE_NAME(MODE)		(etree_mode_name[(int) (MODE)])

enum etree_mode_class { ETREE_MODE_RANDOM, ETREE_MODE_INT, ETREE_MODE_FLOAT, ETREE_MODE_PARTIAL_INT, ETREE_MODE_CC,
		  ETREE_MODE_COMPLEX_INT, ETREE_MODE_COMPLEX_FLOAT,
		  ETREE_MODE_VECTOR_INT, ETREE_MODE_VECTOR_FLOAT,
		  ETREE_MAX_MODE_CLASS};

/* mode MODE  ǥϴ object  Ϲ з ϴ.
   ((integer), Ǽ(floating), Ҽ(complex), Ÿ )  */

extern const enum etree_mode_class etree_mode_class[ETREE_NUM_MACHINE_MODES];
#define ETREE_GET_MODE_CLASS(MODE)		(etree_mode_class[(int) (MODE)])

/*  MODE  integral mode  0  ƴ .  */
#define ETREE_INTEGRAL_MODE_P(MODE)			\
  (ETREE_GET_MODE_CLASS (MODE) == MODE_INT		\
   || ETREE_GET_MODE_CLASS (MODE) == MODE_PARTIAL_INT \
   || ETREE_GET_MODE_CLASS (MODE) == MODE_COMPLEX_INT \
   || ETREE_GET_MODE_CLASS (MODE) == MODE_VECTOR_INT)

/*  MODE  ε-Ҽ mode  0  ƴ .  */
#define ETREE_FLOAT_MODE_P(MODE)		\
  (ETREE_GET_MODE_CLASS (MODE) == MODE_FLOAT	\
   || ETREE_GET_MODE_CLASS (MODE) == MODE_COMPLEX_FLOAT \
   || ETREE_GET_MODE_CLASS (MODE) == MODE_VECTOR_FLOAT)

/*  MODE  complex mode ̶ 0  ƴ .  */
#define ETREE_COMPLEX_MODE_P(MODE)			\
  (ETREE_GET_MODE_CLASS (MODE) == MODE_COMPLEX_INT	\
   || ETREE_GET_MODE_CLASS (MODE) == MODE_COMPLEX_FLOAT)

/*  MODE  vector mode  0  ƴ .  */
#define ETREE_VECTOR_MODE_P(MODE)			\
  (ETREE_GET_MODE_CLASS (MODE) == MODE_VECTOR_INT	\
   || ETREE_GET_MODE_CLASS (MODE) == MODE_VECTOR_FLOAT)

/* mode MODE  object  Ʈ ũ⸦ ϴ.  */

extern const unsigned char etree_mode_size[ETREE_NUM_MACHINE_MODES];
#define ETREE_GET_MODE_SIZE(MODE)		(etree_mode_size[(int) (MODE)])

/* mode MODE  object  basic part  Ʈ ũ⸦ ϴ.  */

extern const unsigned char etree_mode_unit_size[ETREE_NUM_MACHINE_MODES];
#define ETREE_GET_MODE_UNIT_SIZE(MODE)	(etree_mode_unit_size[(int) (MODE)])

/* Object  unit   ϴ.  */

#define ETREE_GET_MODE_NUNITS(MODE)  \
  ((ETREE_GET_MODE_UNIT_SIZE ((MODE)) == 0) ? 0 \
   : (ETREE_GET_MODE_SIZE ((MODE)) / ETREE_GET_MODE_UNIT_SIZE ((MODE))))

/* mode MODE  object  Ʈ ũ⸦ ϴ.  */

extern const unsigned short etree_mode_bitsize[ETREE_NUM_MACHINE_MODES];
#define ETREE_GET_MODE_BITSIZE(MODE)  (etree_mode_bitsize[(int) (MODE)])

#endif /* not HAVE_MACHINE_MODES */

#if defined HOST_WIDE_INT && ! defined GET_MODE_MASK

/* Word   bit  1  ϴ bitmask  µ,  word  mode 
   MODE ο  ̴.  */

extern const unsigned HOST_WIDE_INT etree_mode_mask_array[ETREE_NUM_MACHINE_MODES];

#define ETREE_GET_MODE_MASK(MODE) etree_mode_mask_array[(int) (MODE)]

extern const enum etree_machine_mode etree_inner_mode_array[ETREE_NUM_MACHINE_MODES];

/* Vector  inner element  mode  ȯմϴ.  */

#define ETREE_GET_MODE_INNER(MODE) etree_inner_mode_array[(int) (MODE)]

#endif /* defined (HOST_WIDE_INT) && ! defined GET_MODE_MASK */

#if ! defined ETREE_GET_MODE_WIDER_MODE || ! defined ETREE_GET_MODE_ALIGNMENT \
    || ! defined ETREE_GET_CLASS_NARROWEST_MODE

/*    mode  ϴ. (  QI -> HI -> SI -> DI -> TI).  */

extern const unsigned char etree_mode_wider_mode[ETREE_NUM_MACHINE_MODES];
#define ETREE_GET_MODE_WIDER_MODE(MODE)	((enum etree_machine_mode) etree_mode_wider_mode[(int) (MODE)])

/* ־ size SIZE  mode class CLASS  data   mode  ȯѴ.
    LIMIT  0  ƴ϶, MAX_FIXED_MODE_SIZE  ū mode  
   ʴ´.   ٸ  mode  ã    BLKmode ̴.  */

extern enum etree_machine_mode mode_for_size PARAMS ((unsigned int,
						enum etree_mode_class, int));

/* , ־ ̿ ´   mode  ã´.  */

extern enum etree_machine_mode smallest_mode_for_size 
				PARAMS ((unsigned int, enum etree_mode_class));


/* Input mode  Ȯ  ũ  mode  ȯϸ, н BLKmode
    ȯ.  */

extern enum etree_machine_mode int_mode_for_mode PARAMS ((enum etree_machine_mode));

/* Bit field  ϴµ  ְ mode  ã´.  */

extern enum etree_machine_mode get_best_mode PARAMS ((int, int, unsigned int,
						enum etree_machine_mode, int));

/* Alignment  Ѵ, 1<=result<=BIGGEST_ALIGNMENT.  */

extern unsigned get_mode_alignment PARAMS ((enum etree_machine_mode));

#define ETREE_GET_MODE_ALIGNMENT(MODE) get_mode_alignment (MODE)

/*  class    class  narrowest mode  ϴ. */

extern const enum etree_machine_mode etree_class_narrowest_mode[(int) ETREE_MAX_MODE_CLASS];
#define ETREE_GET_CLASS_NARROWEST_MODE(CLASS) etree_class_narrowest_mode[(int) (CLASS)]

/* Integer mode  ϴµ, integer mode  size  BITS_PER_UNIT 
   BITS_PER_WORD ̰, mode  class  Pmode ̰ mode  size  POINTER_SIZE
   ̴.  */

extern enum etree_machine_mode byte_mode;
extern enum etree_machine_mode word_mode;
extern enum etree_machine_mode ptr_mode;

#endif /* ! defined GET_MODE_WIDER_MODE || ! defined GET_MODE_ALIGNMENT
	  || ! defined GET_CLASS_NARROWEST_MODE */
