#include "libetl.h"

extern int main (int, char **);

long fileSize (const char *);
void ec_file_init (ec_file_t *, unsigned char *, int);

long
fileSize (const char *file)
{
  FILE *fp = fopen(file, "rb");
  long len = 0;

  if (fp != NULL)
    {
      if (fseek (fp, 0L, 2) != -1)
        len = ftell (fp);
      fclose (fp);
    }

  return len;
}

int
main (int argc, char **argv)
{
  etx desc;
  int next_insn_code, next_index, pattern_lineno = 0, error_count = 0;
  struct etx_classobj *etxclass;
  ec_file_t ef;

  progname = "genrecog";

  if (argc <= 1)
    fatal ("no input file name");

  {
    int i, len;
    unsigned char *buf;
    FILE *fd;

      len = fileSize (argv[1]);
      buf = (unsigned char *) xmalloc (sizeof (char) * len + 1);
      fd  = fopen (argv[1], "rb");
      i   = fread (buf, 1, len, fd);
      buf[i] = '\0';
      ec_file_init (&ef, buf, i);
      ef.filename = argv[1];
  }

  if (ecd_init_reader_args (&etxclass, &ef) != SUCCESS_EXIT_CODE)
    return (FATAL_EXIT_CODE);

  next_insn_code = 0;
  next_index = 0;

  /* Read the machine description.  */

  while (1)
    {
      desc = ecd_read_etx (etxclass, &pattern_lineno, &next_insn_code);
      if (desc == NULL)
	break;

      debug_etx (desc);

      next_index++;
    }

  if (error_count)
    return FATAL_EXIT_CODE;

  ecd_finish_reader (etxclass);

  fflush (stdout);
  return (ferror (stdout) != 0 ? FATAL_EXIT_CODE : SUCCESS_EXIT_CODE);
}
